.. _changelog-7-0:

**************************
 MapServer 7.0 Changelog
**************************

The summary of major changes for this release can be found in the `HISTORY.TXT <https://github.com/mapserver/mapserver/blob/rel-7-0-0/HISTORY.TXT>`__
file from the source directory.

.. _changelog-7-0-7:

Changes from 7.0.6 to 7.0.7
===========================

* Commented out vtable entries for msOracleSpatialEscapePropertyName. By that we don't need the additional logic described below anymore (Martin.Icking) : `d190791 <https://github.com/mapserver/mapserver/commit/d1907912880b124c97472066ef20e0c61bf3c213>`__
* Added the option to set a default value for variable substitution in the map's WEB section. To do that there is a new method applyHashTableDefaultSubstitutions that is being called in msApplyDefaultSubstitutions with the map's WEB section as the hash table to work on (Martin.Icking) : `572bd76 <https://github.com/mapserver/mapserver/commit/572bd765e7a0f55b8826a9bdbd2b661e07ff44b9>`__
* WCS 2.0 RectifiedGrid: use 'lon lat' and 'x y' labels even with CRS with 'inverted axis' order (Even Rouault) : `3be5442 <https://github.com/mapserver/mapserver/commit/3be54424026e24fb37b3bff82027b28484100452>`__
* WCS 2.0 DescribeCoverage result: fix RectifiedGrid.origin.Point to correspond to the coordinate of the pixel center (fixes  `#5511 <https://github.com/mapserver/mapserver/issues/5511>`__ ) (Even Rouault) : `31c25df <https://github.com/mapserver/mapserver/commit/31c25df6be067a59ffb89100f215d2d65840e364>`__
* UVRaster: fix reprojection issue of map extent to layer projection (fixes  `#5501 <https://github.com/mapserver/mapserver/issues/5501>`__ ) (Even Rouault) : `2a990dc <https://github.com/mapserver/mapserver/commit/2a990dc46f13ed8b965f0d83cde7df7da17b831f>`__
* Fix regression introduced by latest commit 8f85f8db46e65a3a4e8d3ec245ea90a56b6d794c ( `#5502 <https://github.com/mapserver/mapserver/issues/5502>`__ ) (Even Rouault) : `1ee7e0e <https://github.com/mapserver/mapserver/commit/1ee7e0e87125fb1f94ec382a8bd71d2c09c56ea4>`__
* UVRaster: support layers with lon_wrap=180 projection ( `#5502 <https://github.com/mapserver/mapserver/issues/5502>`__ ) (Even Rouault) : `8f85f8d <https://github.com/mapserver/mapserver/commit/8f85f8db46e65a3a4e8d3ec245ea90a56b6d794c>`__
* msSOSGetCapabilities(): use proper layer when generating the gml:name from sos_offering_name metadata (patch by wdc-rsat, fixes  `#5506 <https://github.com/mapserver/mapserver/issues/5506>`__ ) (Even Rouault) : `c7a1e51 <https://github.com/mapserver/mapserver/commit/c7a1e517d5dd2dd80901008e9860cd589f1685a1>`__
* WCS 1.1 DescribeCoverage response: honour EPSG axis order for GridOrigin and GridOffsets ( `#5504 <https://github.com/mapserver/mapserver/issues/5504>`__ ) (Even Rouault) : `4f75206 <https://github.com/mapserver/mapserver/commit/4f7520631f03d1347dadf529db6da55c2ea57186>`__
* msSLDApplySLD(): fix wrong index use (patch by wdc-rsat, fixes  `#5505 <https://github.com/mapserver/mapserver/issues/5505>`__ ) (Even Rouault) : `91fafe4 <https://github.com/mapserver/mapserver/commit/91fafe426c00c348c068be7deb35cd45d1fe262d>`__
* Fix kerneldensity layer not to loose connection type on reopen ( `#5497 <https://github.com/mapserver/mapserver/issues/5497>`__ ) (Tamas Szekeres) : `38f3cae <https://github.com/mapserver/mapserver/commit/38f3cae73d6ad55a3d16786441a065275f3335b4>`__
* WFS client layer: fix wrong BBOX argument in WFS 1.1 with EPSG code with non-axis inversion (patch by richie21, fixes  `#5496 <https://github.com/mapserver/mapserver/issues/5496>`__ ) (Even Rouault) : `7ca0c1c <https://github.com/mapserver/mapserver/commit/7ca0c1c7d2ceef9c7376e7bc532e7131e0aeda4b>`__
* JPEG output: add compatibility with libjpeg-turbo 1.5.2 (https://github.com/libjpeg-turbo/libjpeg-turbo/issues/162) (Even Rouault) : `04d3a61 <https://github.com/mapserver/mapserver/commit/04d3a61493dd3842ffcb54acd79cb30a1ebb048b>`__
* msProjectionsDiffer(): restrict attempts normalization with proj.4 (Even Rouault) : `581ec9f <https://github.com/mapserver/mapserver/commit/581ec9fcdd42c88348277d1a35a9f48ebfd382bc>`__
* msExtentsOverlap(): optimize when layer and map projections are the same (Even Rouault) : `8501873 <https://github.com/mapserver/mapserver/commit/8501873362d8db024221869eb4a9bacef1c04690>`__
* msLayerIsVisible(): speed it up by doing layer vs map scale comparisons before extent comparison (Even Rouault) : `6a5cad3 <https://github.com/mapserver/mapserver/commit/6a5cad3dbc10e2cafd95269402a92fda34d01385>`__
* msDrawMap(): optimize pre-processing of WMS/WFS layers (Even Rouault) : `226d19a <https://github.com/mapserver/mapserver/commit/226d19a6fe68ac1e0f19cc3a593841e3da54ce22>`__
* msDrawTextSymbol(): fix compiler warning about unused return value (Even Rouault) : `35b82b9 <https://github.com/mapserver/mapserver/commit/35b82b93fe26e3b11d1e3cdefe11638bfda2966f>`__
* Fix ANGLE AUTO in STYLE during mapObj.clone() `#5483 <https://github.com/mapserver/mapserver/issues/5483>`__ (Bernard Bielecki) : `08780c2 <https://github.com/mapserver/mapserver/commit/08780c2659cb645e3b32a9dc69579d0a122c1cfe>`__
* Fix MSVC2015+ builds ( `#5274 <https://github.com/mapserver/mapserver/issues/5274>`__ ) (Tamas Szekeres) : `6c09697 <https://github.com/mapserver/mapserver/commit/6c0969733c13b214dace9490bbdc898791077185>`__
* Fix label of scalebar and legend set with SWIG mapscript  `#5470 <https://github.com/mapserver/mapserver/issues/5470>`__  (Tamas Szekeres) : `870e027 <https://github.com/mapserver/mapserver/commit/870e027dfbfa0fa26240e46fe8c18f244dbb2945>`__
* Fix potential memory corruption caused by freeSVGCache ( `#5471 <https://github.com/mapserver/mapserver/issues/5471>`__ ) (Tamas Szekeres) : `8a5e0f3 <https://github.com/mapserver/mapserver/commit/8a5e0f3bcea89ca7045e8673e99f4fa6cf69eef5>`__
* OGR output: fix "ESRI Shapefile" output with FORMATOPTION "STORAGE=memory" (Even Rouault) : `2c1e5c5 <https://github.com/mapserver/mapserver/commit/2c1e5c50791cac205cfbeed0e1fa98bb421f5c5c>`__
* Fix error to support Oracle compound elements for GTYPE 2007 (multipolygon) and not only for GTYPE 2003 (polygon) (Martin.Icking) : `be21bcf <https://github.com/mapserver/mapserver/commit/be21bcf37b47bfce77d011ec6abef15d495926a5>`__
* Enclose the sortby property in double quotes by putting the result of  msLayerEscapePropertyName into double quotes (Martin.Icking) : `d5f89a3 <https://github.com/mapserver/mapserver/commit/d5f89a3353854b0f6a8eda0758d99e74372fdf9f>`__
* Allow using double quoted aliases for Oracle column aliases (Martin Icking) : `608a118 <https://github.com/mapserver/mapserver/commit/608a118d407223fa33b20c1ff7a431596c2e2e46>`__
* Enabled WFS sortby for Oracle plugin, quoted sortby parameter to enable non-capitalized column names (Martin.Icking) : `c08e349 <https://github.com/mapserver/mapserver/commit/c08e349300283ee39bba8955045d4b6cf6b3419f>`__
* Allow for build path name with spaces [in csharp mapscript] (Martin.Icking) : `d7abbc6 <https://github.com/mapserver/mapserver/commit/d7abbc6eb3261b100797f3ad6ea81679f8c1ad5f>`__
* This fix allows to have an out-of-source build on any location - previously it was assumed that the mapscript csharp sources had a fixed path relative to the build (Martin Icking) : `8f475c6 <https://github.com/mapserver/mapserver/commit/8f475c6f2619204b2cbece7a6fbd2913aeb49f23>`__
* Removed bug that caused MapServer only to use the Oracle TranslateFilter method at the first call e.g. in an FCGI environment (Martin Icking) : `3e8c9c8 <https://github.com/mapserver/mapserver/commit/3e8c9c8e52b3beaab454afab6d71ef1f3bdf06cd>`__
* Repeat transformation if extent is extreme (David Shorthouse) : `bbfa866 <https://github.com/mapserver/mapserver/commit/bbfa86661216c370fa5e4860ca4d4a9efcbc3a7e>`__

.. _changelog-7-0-6:

Changes from 7.0.5 to 7.0.6
===========================

* [OGR] Correctly extract BBOX from an Intersects() filter. Complementary fix to `f53fd782 <https://github.com/mapserver/mapserver/commit/f53fd782>`__ (Even Rouault) : `aae74ff <https://github.com/mapserver/mapserver/commit/aae74ff2abed3f2f8fe1f76c9b4bbccf15023dc1>`__
* WFS: complementary fix for "wfs_use_default_extent_for_getfeature" "yes" layers (Even Rouault) : `1df03be <https://github.com/mapserver/mapserver/commit/1df03be1bbb3343f78e582ca04eb929e34f3a32c>`__
* msResampleGDALToMap(): restrict fix done for `#1715 <https://github.com/mapserver/mapserver/issues/1715>`__ , to avoid regressions like `#5445 <https://github.com/mapserver/mapserver/issues/5445>`__  (Even Rouault) : `3e262f4 <https://github.com/mapserver/mapserver/commit/3e262f4ca736516bf303b7c9389ffbf89a5be430>`__
* Suppress GEOS error in offsetcurve and fall back to the original behavior ( `#5442 <https://github.com/mapserver/mapserver/issues/5442>`__ ) (Tamas Szekeres) : `70cbb55 <https://github.com/mapserver/mapserver/commit/70cbb553e1a25e7341be76e505a62169c36ad9b6>`__
* Fix rendering label shadow ( `#5438 <https://github.com/mapserver/mapserver/issues/5438>`__ ) (Tamas Szekeres) : `f495c48 <https://github.com/mapserver/mapserver/commit/f495c4874f5cd7985f7002af1e71fd62c01cff9f>`__
* Add MSSQL support for PropertyIsLike ( `#5428 <https://github.com/mapserver/mapserver/issues/5428>`__ ) (Tamas Szekeres) : `d644c84 <https://github.com/mapserver/mapserver/commit/d644c8405e32987915c8fef8f757d4892fbccde3>`__
* Restore error reporting for invalid attribute filters ( `#5427 <https://github.com/mapserver/mapserver/issues/5427>`__ ) (Tamas Szekeres) : `c549798 <https://github.com/mapserver/mapserver/commit/c5497982fd97cf2eba84eb5af11f19c1cf3cad7f>`__

.. _changelog-7-0-5:

Changes from 7.0.4 to 7.0.5
===========================

* Shape tileindex: fix issues (crash and invalid result) related with interactions between msTiledSHPNextShape() and msTiledSHPGetShape() (Even Rouault) : `1aea33a <https://github.com/mapserver/mapserver/commit/1aea33ab9a725dadf2358270570f3bf6b52d3b07>`__
* [PostGIS] Format literal number in filter as integer when possible to avoid performance issues (Even Rouault) : `b814f93 <https://github.com/mapserver/mapserver/commit/b814f93cda0bf9b9b8ed7f32626803519d3d1571>`__
* Forming the tag <OnlineResource> in the sld-file from the SYMBOL type MS_SYMBOL_SVG (Sergey Morev) : `48de40e <https://github.com/mapserver/mapserver/commit/48de40e61fdb56c677a9071f1b8eb5c110452601>`__
* msResampleGDALToMap(): restrict full size acquisition in weird reprojection cases to raster of 'modest' size ( `#5402 <https://github.com/mapserver/mapserver/issues/5402>`__ ) (Even Rouault) : `bd9ff63 <https://github.com/mapserver/mapserver/commit/bd9ff630f5f02dfa4f908eeba7a391f39f4fd9b8>`__
* msResampleGDALToMap(): amend e0a3448f3f42d20a0d271709c8629a5b40d13951 to fix regression of  `#5402 <https://github.com/mapserver/mapserver/issues/5402>`__  (Even Rouault) : `3d9f71a <https://github.com/mapserver/mapserver/commit/3d9f71ae4812efc9144546911e649bd3b03c8347>`__
* Allow paging for msQueryByFilter(). (Steve Lime) : `761a73a <https://github.com/mapserver/mapserver/commit/761a73a5f4fcdccc5914519f786d22e24ac5a7b5>`__
* msProjectRect(): fix when reprojecting from north polar stereographic to WGS84. (Even Rouault) : `14243fa <https://github.com/mapserver/mapserver/commit/14243fa9c605bd497d5a8aa6c725cf98045ff9f8>`__
* msTransformMapToSource(), msNearestRasterResampler(), msBilinearRasterResampler(): fixes for lon_wrap=180 (Even Rouault) : `4c2aeb4 <https://github.com/mapserver/mapserver/commit/4c2aeb4bbd229723d8ea67c337cf02350575b2ae>`__
* Fix memory leaks ( `#5397 <https://github.com/mapserver/mapserver/issues/5397>`__ ) (Tamas Szekeres) : `f1857d4 <https://github.com/mapserver/mapserver/commit/f1857d439eaf6de59f6df3219828ff0116fd7ed8>`__
* Fix crash if the prj cannot be opened ( `#5395 <https://github.com/mapserver/mapserver/issues/5395>`__ ) (Tamas Szekeres) : `e85f8e3 <https://github.com/mapserver/mapserver/commit/e85f8e39b5fa2931cab42ec84758771103c90700>`__
* Legend icon for label layers should not rotate ( `#5391 <https://github.com/mapserver/mapserver/issues/5391>`__ ) (Tamas Szekeres) : `f125a13 <https://github.com/mapserver/mapserver/commit/f125a134011b9ff3842a5a99d3592b02e82cec41>`__
* GRID layer: fix label positioning when requesting WGS84 graticule in EPSG:3857 (Even Rouault) : `fc36c0a <https://github.com/mapserver/mapserver/commit/fc36c0aa8b0277ae10770a6c959ad25927c5306b>`__
* Declare nLayerOrder where it's used. ( `#5387 <https://github.com/mapserver/mapserver/issues/5387>`__ ) (Landry Breuil) : `1326958 <https://github.com/mapserver/mapserver/commit/132695864b27bb6fced9a866f35365f445889a00>`__
* Oracle Spatial: Include mapows.h ( `#5373 <https://github.com/mapserver/mapserver/issues/5373>`__ ) (Martin Icking) : `027f421 <https://github.com/mapserver/mapserver/commit/027f421ce8df06331a9cf9d61d55ebd2b1ba6005>`__
* Fix Character type handling in WMS dimension filters ( `#5374 <https://github.com/mapserver/mapserver/issues/5374>`__ ) (Tamas Szekeres) : `e075ccb <https://github.com/mapserver/mapserver/commit/e075ccbd022bd44fdb31bdf2c9d563383c96cc7d>`__
* [OGR] Translate as much as possible MapServer expressions to OGR SQL attribute and spatial filters (Even Rouault) : `f53fd78 <https://github.com/mapserver/mapserver/commit/f53fd782ccbe04033d4088047615f08968dcede0>`__
* msResampleGDALToMap(): fix inappropriate cellsize computation when loading (well beyond) full source raster. (Even Rouault) : `e0a3448 <https://github.com/mapserver/mapserver/commit/e0a3448f3f42d20a0d271709c8629a5b40d13951>`__
* msResampleGDALToMap(): fix issue that cause line pattern in image mosaic ( `#1715 <https://github.com/mapserver/mapserver/issues/1715>`__ ) (Even Rouault) : `026847b <https://github.com/mapserver/mapserver/commit/026847b1c962cdd666d28cfbe38ac40fff54ffbb>`__
* Oracle - fixing memory handling error (Pierre Mauduit) : `bbe23e8 <https://github.com/mapserver/mapserver/commit/bbe23e8c0b9cce174dc3ff313e3e5d3560c1e62b>`__
* Add msIO_getAndStripStdoutBufferMimeHeaders to deal with all MIME headers. (Even Rouault) : `10fe3d7 <https://github.com/mapserver/mapserver/commit/10fe3d78c3f3a3e2cbc64ede7c091a60f11a4e22>`__
* Use include paths from php-config when include path not found. (Bas Couwenberg) : `8fd1c73 <https://github.com/mapserver/mapserver/commit/8fd1c73d75cd66caa2a04a2da5a7d0390b4b9dd6>`__

.. _changelog-7-0-4:

Changes from 7.0.3 to 7.0.4
===========================

* Security release for CVE-2017-5522
* For GPKG datasources with Spatialite support, translate mapserver expressions to SQL (Even Rouault) : `60fd6de <https://github.com/mapserver/mapserver/commit/60fd6deb237f3e5f246c4f34a9832f140bdc6e7e>`__
* Optimize msDrawRasterGDAL_16BitClassification() runtime. (Even Rouault) : `adf3383 <https://github.com/mapserver/mapserver/commit/adf3383e52a91ded988b80a4b296a88c6bdf941c>`__
* Legend: draw icon for raster gradient classes ( `#1305 <https://github.com/mapserver/mapserver/issues/1305>`__ ) (Even Rouault) : `19d77c5 <https://github.com/mapserver/mapserver/commit/19d77c52467d445e678a291aaf0265f49c4e2176>`__
* Fix cluster filter propagation to the source layer ( `#5364 <https://github.com/mapserver/mapserver/issues/5364>`__ ) (Tamas Szekeres) : `7dc87fe <https://github.com/mapserver/mapserver/commit/7dc87fe671930f5e191a0c3dbff4b0c75b44149a>`__
* Update copyright date (Jeff McKenna) : `940ae5e <https://github.com/mapserver/mapserver/commit/940ae5e26f3898e56abf28bb7aaeaaf0e7d56a92>`__
* Fix cluster with WMS dimension issue ( `#5364 <https://github.com/mapserver/mapserver/issues/5364>`__ ) (Tamas Szekeres) : `1a65c62 <https://github.com/mapserver/mapserver/commit/1a65c6209f6a1241fc3432e35d91bdde563b1d2e>`__
* msTransformMapToSource(): fix behaviour at lon_wrap +/- 180 deg (Even Rouault) : `722716c <https://github.com/mapserver/mapserver/commit/722716c49de2399f54b275ab31437f0e8c92cd63>`__
* WFS: avoid 'eating' the last character of WFS 2.0 stored queries stored in an external file (Even Rouault) : `b5c02b4 <https://github.com/mapserver/mapserver/commit/b5c02b4c6c485126d414cd0c4fffd05b2c28d25d>`__
* WFS: fix taking into account of wfs_use_default_extent_for_getfeature. Logic added in 7.0.3 was inverted... (Even Rouault) : `6beab5e <https://github.com/mapserver/mapserver/commit/6beab5e455fd4d0c4292bd5cf77655617a1dae2f>`__
* Update README.WIN32 for MapServer and PHP/MapScript ( `#5357 <https://github.com/mapserver/mapserver/issues/5357>`__ ) (Alexander Gabriel) : `1534710 <https://github.com/mapserver/mapserver/commit/153471013be25562ebb3d83f17b7312834e3a4fd>`__

.. _changelog-7-0-3:

Changes from 7.0.2 to 7.0.3
===========================

* Security release for CVE-2016-9839
* Free expression tokens, which may store an index to an iteminfo, when iteminfo is freed. ( `#5161 <https://github.com/mapserver/mapserver/issues/5161>`__ ) (Martin Kofahl) : `7413952 <https://github.com/mapserver/mapserver/commit/7413952a17f826926066fa46dbc2c784117c5068>`__
* cmake/FindICONV.cmake did not find iconv on windows ( `#5346 <https://github.com/mapserver/mapserver/issues/5346>`__ ) (Alexander Gabriel) : `14ce312 <https://github.com/mapserver/mapserver/commit/14ce31235fe9400275114666673ab7013006663c>`__
* fix issues when compiling PHP-MapScript with VS2012 Express ( `#5346 <https://github.com/mapserver/mapserver/issues/5346>`__ ) (Alexander Gabriel) : `54d645c <https://github.com/mapserver/mapserver/commit/54d645c18d0293f7e5821e9d740542408083f955>`__
* Fix variable declaration compilation error on Windows ( `#5346 <https://github.com/mapserver/mapserver/issues/5346>`__ ) (Alexander Gabriel) : `2f240de <https://github.com/mapserver/mapserver/commit/2f240de9ac97c1e7cc3253541b590a45271a334d>`__
* Fix LNK2019 build error on windows ( `#5346 <https://github.com/mapserver/mapserver/issues/5346>`__ ) (Alexander Gabriel) : `bcf7e7e <https://github.com/mapserver/mapserver/commit/bcf7e7ef350abe8649b4ca1834d163912c3f5fc2>`__
* Fix utfgrid text encoding to work with Windows ( `#5342 <https://github.com/mapserver/mapserver/issues/5342>`__ ) (geographika) : `2ab0dc0 <https://github.com/mapserver/mapserver/commit/2ab0dc0187b0a89560d5ce88c1e1208a3def6108>`__
* Allow FEATURE->ITEMS to be set by URL ( `#5335 <https://github.com/mapserver/mapserver/issues/5335>`__ ) (Thomas Bonfort) : `93cc1ed <https://github.com/mapserver/mapserver/commit/93cc1edab40ed0e32c46beb3a22e881c08f00952>`__
* Fix glyph orientation when switching from cairo to AGG ( `#5338 <https://github.com/mapserver/mapserver/issues/5338>`__ ) (Thomas Bonfort) : `82ec23b <https://github.com/mapserver/mapserver/commit/82ec23b2336087df94bfe41f04bec4dfb5102c2f>`__
* Fix build issue with php >= 5.6.25 ( `#5318 <https://github.com/mapserver/mapserver/issues/5318>`__ ) (Thomas Bonfort) : `d5cc584 <https://github.com/mapserver/mapserver/commit/d5cc5840683bded229dbc2cc7d534db6d1e1f386>`__
* Backport  `#4928 <https://github.com/mapserver/mapserver/issues/4928>`__  and  `#5356 <https://github.com/mapserver/mapserver/issues/5356>`__  (Thomas Bonfort) : `022d24b <https://github.com/mapserver/mapserver/commit/022d24bd34196b6dca67053fb797a6980210bc54>`__
* OGR Spatialite: do not be case sensitive if DATA is a SELECT ... FROM table_name (Even Rouault) : `491397c <https://github.com/mapserver/mapserver/commit/491397c126ebec3e8a97f5c91e018546cc168fcf>`__
* OGR: add a  "wfs_use_default_extent_for_getfeature" "yes" LAYER.METADATA (Even Rouault) : `45037eb <https://github.com/mapserver/mapserver/commit/45037eb0601e2f48ae548e2cd28b29b429644870>`__
* add msautotest script for windows (Jeff McKenna) : `2934c6e <https://github.com/mapserver/mapserver/commit/2934c6e18774cdfcd2f9f05f1453744058bc4120>`__
* change default max mapsize to 4096 (fixes  `#5349 <https://github.com/mapserver/mapserver/issues/5349>`__ ) (Jeff McKenna) : `1e8266b <https://github.com/mapserver/mapserver/commit/1e8266bd20e6c568a439b0b3ea7405d2217fb699>`__
* OGR Spatialite: avoid useless CAST() in filter, and use join for spatial filtering. (Even Rouault) : `22dc081 <https://github.com/mapserver/mapserver/commit/22dc081f1060ca40e0b209e7bb3e9aa0ca8b5ac3>`__
* Don't return verbose OGR error messages to clients ( `#5356 <https://github.com/mapserver/mapserver/issues/5356>`__ ) (Thomas Bonfort) : `3d52307 <https://github.com/mapserver/mapserver/commit/3d52307cf0033e3275975b668b7138ba1343f28d>`__
* Fix segfault on WFS filters with empty literals (PostGIS + Spatialite). Implement PropertyIsNull for those layers ( `#5347 <https://github.com/mapserver/mapserver/issues/5347>`__ ) (Even Rouault) : `4cb057c <https://github.com/mapserver/mapserver/commit/4cb057c7ae2d141ae00c91d15c9a7d3a5fbf23b6>`__
* Reorder spatial operator arguments for mssql ( `#5352 <https://github.com/mapserver/mapserver/issues/5352>`__ ) (Tamas Szekeres) : `51415f7 <https://github.com/mapserver/mapserver/commit/51415f75e5d6abbf162ace0401eaf4ed7552d8a3>`__
* Filters: add whitespace between and and next part (relates to  `#5352 <https://github.com/mapserver/mapserver/issues/5352>`__ ) (Even Rouault) : `5b6ccd0 <https://github.com/mapserver/mapserver/commit/5b6ccd0f8aa672799351446d6f271015101973bf>`__
* update copyright (Jeff McKenna) : `b695d28 <https://github.com/mapserver/mapserver/commit/b695d28e85f6035d6e28f224461a1d7e75fa84a4>`__
* update win32 binaries link (Jeff McKenna) : `af77d43 <https://github.com/mapserver/mapserver/commit/af77d43d37de16f62b18ec4600d2ed4e3a47751b>`__
* Add c# typemap for setLayerDrawingOrder ( `#5336 <https://github.com/mapserver/mapserver/issues/5336>`__ ) (Tamas Szekeres) : `4a988fe <https://github.com/mapserver/mapserver/commit/4a988fe1a1edf31997a0b84fdedf5756f0775a21>`__
* Remove msCleanupOnSignal log messages ( `#5254 <https://github.com/mapserver/mapserver/issues/5254>`__ ) (Thomas Bonfort) : `51fef1b <https://github.com/mapserver/mapserver/commit/51fef1b42017e5392307182621689d453724a4a5>`__
* Fix timestamp handling in the MSSQL driver ( `#5334 <https://github.com/mapserver/mapserver/issues/5334>`__ ) (Tamas Szekeres) : `6dbbd3b <https://github.com/mapserver/mapserver/commit/6dbbd3b780c1e5f5d42adb9438fc6b8e11a37f0a>`__

.. _changelog-7-0-2:

Changes from 7.0.1 to 7.0.2
===========================

* Fix memory/locking errors on kerneldensity layers ( `#5330 <https://github.com/mapserver/mapserver/issues/5330>`__ ) (Sander Jansen) : `3493927 <https://github.com/mapserver/mapserver/commit/349392793f8a3aa172102e89528369d773d85931>`__
* Don't apply layer scalefactor to legend text ( `#5268 <https://github.com/mapserver/mapserver/issues/5268>`__ ) (Thomas Bonfort) : `d7a47e6 <https://github.com/mapserver/mapserver/commit/d7a47e66dfa88f87972ca36f5afd659c0876bcb9>`__
* Apply legend label offset if set ( `#5267 <https://github.com/mapserver/mapserver/issues/5267>`__ ) (Thomas Bonfort) : `d7b5df7 <https://github.com/mapserver/mapserver/commit/d7b5df7e2e1a2a1af2a302ee6a221381ebd2a67c>`__
* Fix clipped SVG symbol when rotated ( `#5264 <https://github.com/mapserver/mapserver/issues/5264>`__ ) (Oliver Tonnhofer) : `b1604a7 <https://github.com/mapserver/mapserver/commit/b1604a7>`__
* Fix memory leaks  ( `#5329 <https://github.com/mapserver/mapserver/issues/5329>`__ ) (Sander Jansen) : `28991f4 <https://github.com/mapserver/mapserver/commit/28991f4eb602bc29156cf7793189b073e9e2f922>`__
* Fix segfault on offsetted labels with multiple styles ( `#5326 <https://github.com/mapserver/mapserver/issues/5326>`__ ) (Thomas Bonfort) : `8301131 <https://github.com/mapserver/mapserver/commit/83011315f539c8a5bf86550cea0c08e77b563e64>`__
* Fix position of rendered offsetted labelpnt marker ( `#5326 <https://github.com/mapserver/mapserver/issues/5326>`__ ) (Thomas Bonfort) : `370a81c <https://github.com/mapserver/mapserver/commit/370a81c3b870ce82675c545da24f51ed4311b952>`__
* Fix position of labelpoly on offsetted labels ( `#5326 <https://github.com/mapserver/mapserver/issues/5326>`__ ) (Thomas Bonfort) : `cd70b0f <https://github.com/mapserver/mapserver/commit/cd70b0f4c6bd4b76736333bd02aa7d179f0619b5>`__
* Add support for the csharp debug builds in cmake (Tamas Szekeres) : `b4f41cc <https://github.com/mapserver/mapserver/commit/b4f41ccac04ff6272ceffc8ea361c1cf4e8461ac>`__
* Fix ANCHORPOINT not being written for TRUETYPE and PIXMAP symbols ( `#5073 <https://github.com/mapserver/mapserver/issues/5073>`__ ) (Tamas Szekeres) : `81ef223 <https://github.com/mapserver/mapserver/commit/81ef223e0480b63a1671377687c37d9d22e4b035>`__
* Fix memory leak on hashTableSubstituteString ( `#5325 <https://github.com/mapserver/mapserver/issues/5325>`__ ) (Thomas Bonfort) : `fd55fd3 <https://github.com/mapserver/mapserver/commit/fd55fd35c9766f80ffe8095e96452166c832b479>`__
* Fix wording of mssql2008 and postgis error messages  `#5324 <https://github.com/mapserver/mapserver/issues/5324>`__  (Bas Couwenberg) : `66309ee <https://github.com/mapserver/mapserver/commit/66309eebb7ba0dc70469efeb40f865a8e88fafbd>`__
* Fix typo on PERCENTAGES in mapfile writer (Thomas Bonfort) : `a0437f8 <https://github.com/mapserver/mapserver/commit/a0437f8c3f1356fbb974f824ac7b3695db71d824>`__
* Fix behaviour for inner ring touching its outer ring in msGetInnerList() ( `#5299 <https://github.com/mapserver/mapserver/issues/5299>`__ ) (Even Rouault) : `f8e104e <https://github.com/mapserver/mapserver/commit/f8e104e59df25e8a96bad8e36ca99539a353aae5>`__
* Do not install spatial filter on a layer without geometry to avoid a OGR error to be triggered at msOGRFileNextShape() time (typical of a SQLite/Spatialite/GPKG SQL select layer that returns zero records) ( `#5317 <https://github.com/mapserver/mapserver/issues/5317>`__ ) (Even Rouault) : `9b8a907 <https://github.com/mapserver/mapserver/commit/9b8a907eb6bf076b0ab1399a55245662294c0ce1>`__
* Update comments in utfgrid code (Seth Girvin) : `2f547e1 <https://github.com/mapserver/mapserver/commit/2f547e17c669b1cc8ef5d42e472988498903a899>`__
* Propagate LIMIT to spatialite spatial filter sub-query, when possible (Even Rouault) : `e3ff20a <https://github.com/mapserver/mapserver/commit/e3ff20af22214696a5c8a2bdae89cc1b280bed1b>`__
* Fix msOGRGetPaging() (Even Rouault) : `e6b66a6 <https://github.com/mapserver/mapserver/commit/e6b66a66e74351e39ddc7d0628df5340aa1ab7b1>`__
* Fix build when USE_OGR is not defined (Even Rouault) : `892deaf <https://github.com/mapserver/mapserver/commit/892deaf5a84e9a619ffc1f6ca2d6ec37dceaab7b>`__
* Enable translation for maxfeatures/startindex to SQL LIMIT/OFFSET in Spatialite case (Even Rouault) : `8ae17b3 <https://github.com/mapserver/mapserver/commit/8ae17b3fd59b822f23b9276f7d53e418b8caf63b>`__
* Move all logic to detect if we can use Spatialite dialect to msOGRFileOpen(). No functional change (Even Rouault) : `2a6ad64 <https://github.com/mapserver/mapserver/commit/2a6ad64361b22f01e338d8379f010640a63a153a>`__
* Fix compound polygon rendering in PostGIS ( `#5012 <https://github.com/mapserver/mapserver/issues/5012>`__ ) (Thomas Bonfort) : `0152e04 <https://github.com/mapserver/mapserver/commit/0152e0436c79d294896401cf8ad010d67fe09bd6>`__
* MSSQL driver: Get feature attributes as UTF8 strings ( `#5308 <https://github.com/mapserver/mapserver/issues/5308>`__ ) (Tamas Szekeres) : `dd336bc <https://github.com/mapserver/mapserver/commit/dd336bcfab8ecbaab4974eeb28fbde80309c6b70>`__
* Potential fix for SELECT ... FROM a Spatialite view (probably fix  `#5218 <https://github.com/mapserver/mapserver/issues/5218>`__ ) (Even Rouault) : `375a7ae <https://github.com/mapserver/mapserver/commit/375a7aea204eb1eb40327a53592a9e1f9b057ead>`__
* Add support for DescribeFeatureType with gml_types=auto for the MSSQL driver ( `#5305 <https://github.com/mapserver/mapserver/issues/5305>`__ ) (Tamas Szekeres) : `59650f2 <https://github.com/mapserver/mapserver/commit/59650f22552edd30270bfb5d8da86c9ef7acd41f>`__
* Fix support for Spatialite views (Even Rouault) : `58ce9c4 <https://github.com/mapserver/mapserver/commit/58ce9c453b67eb2fb73e32dcfb0bb5c025ab0458>`__
* Improve performance when DATA of a Spatialite DB is a simple 'SELECT ... FROM tablename' to for example select from multiple geometry columns (Even Rouault) : `b39fd15 <https://github.com/mapserver/mapserver/commit/b39fd15c55f32922625e4f5aac5d93eaf94c1401>`__
* Fix wrong mapping of field indexes when SQL layer is composed, e.g. with a WMS request on a Spatialite DB. (Even Rouault) : `5c8f201 <https://github.com/mapserver/mapserver/commit/5c8f20124f3867d68dee38aa51ebf04d6ee85760>`__
* msOGRFileWhichShapes(): fix case where there is no items (Even Rouault) : `b007fdb <https://github.com/mapserver/mapserver/commit/b007fdb06871dc95e5b2577c0bd83d16b31459bd>`__
* Fix WMS blank for classified raster with NaN `#5289 <https://github.com/mapserver/mapserver/issues/5289>`__  (Radim Blazek) : `c3a5759 <https://github.com/mapserver/mapserver/commit/c3a5759dae997c8cfb370b7d1b7cdbb10b1d84de>`__
* Fix slow filter BBOX evaluation with tileindex of shapefile ( `#5291 <https://github.com/mapserver/mapserver/issues/5291>`__ ) (Even Rouault) : `9f1ef95 <https://github.com/mapserver/mapserver/commit/9f1ef9510c1b2e38f60c1fab4d7fa8cfca38a554>`__
* Fix compilation error with OGR support disabled (Thomas Bonfort) : `a56815b <https://github.com/mapserver/mapserver/commit/a56815ba2e77734a62d2099cd34ba7d4dd5a2db8>`__
* Add support to get raw image data in csharp ( `#5293 <https://github.com/mapserver/mapserver/issues/5293>`__ ) (Tamas Szekeres) : `3dc88f7 <https://github.com/mapserver/mapserver/commit/3dc88f7bf2d05039b7f7b3fc5da0c1db838b39c2>`__
* Implement expression conversion to Spatialite SQL (Ari Jolma) : `3cf682d <https://github.com/mapserver/mapserver/commit/3cf682d17003521213868f1e727d7be7a3263c7e>`__
* Recalculate scale factor in drawLegendIcon from mapscript ( `#5287 <https://github.com/mapserver/mapserver/issues/5287>`__ ) (Tamas Szekeres) : `7121ac7 <https://github.com/mapserver/mapserver/commit/7121ac7c32642b9c1bf182ef66e2a6324c04ebbe>`__
* Allow to specify empty color in mapscript ( `#5286 <https://github.com/mapserver/mapserver/issues/5286>`__ ) (Tamas Szekeres) : `f2b0310 <https://github.com/mapserver/mapserver/commit/f2b03103f8134b1315fcaf83cb13e45c03b5b37c>`__
* Fix layer compositer issues ( `#5283 <https://github.com/mapserver/mapserver/issues/5283>`__ ) (Tamas Szekeres) : `f60648e <https://github.com/mapserver/mapserver/commit/f60648efd4f01df5a0bc7218f37e34df4a0f8633>`__
* Fix crash in drawQuery for layers with labelitem ( `#5281 <https://github.com/mapserver/mapserver/issues/5281>`__ ) (Tamas Szekeres) : `5870da4 <https://github.com/mapserver/mapserver/commit/5870da474f9d834e734e7a4fe2e49ba89d5165ab>`__
* Add UTF8 marshaler to MapScript C# ( `#5275 <https://github.com/mapserver/mapserver/issues/5275>`__ ) (Tamas Szekeres) : `8771b59 <https://github.com/mapserver/mapserver/commit/8771b597eaee8f4b74afa5844247ed0bb5b86714>`__
* Fix Cluster Layers Filter Translation ( `#5205 <https://github.com/mapserver/mapserver/issues/5205>`__ ) (Tamas Szekeres) : `cc03cee <https://github.com/mapserver/mapserver/commit/cc03ceec064a0b2fb07e1f68f5b189dcdb2d67d3>`__
* Fix issue of GetCapabilities request is extremely slow when OWS_LAYER_GROUP is used (Anuruddha Abhayasinghe) : `55558b3 <https://github.com/mapserver/mapserver/commit/55558b35cd1cb870cb235da24cf0ef9d9a7e9633>`__
* Fix absence of XML escaping in GetCapabilities response (Even Rouault) : `1058774 <https://github.com/mapserver/mapserver/commit/105877468590e99401d234e1bbac13d7645b77d0>`__
* Add encoding property to PHP mapscript source (Jeff McKenna) : `abd3493 <https://github.com/mapserver/mapserver/commit/abd34934c6d97a479977e22695681ffcc9c6b3cd>`__
* Fix filter of MS_TOKEN_LITERAL_TIME in PostGIS `#5265 <https://github.com/mapserver/mapserver/issues/5265>`__  (Emanuele Di Giacomo) : `7295312 <https://github.com/mapserver/mapserver/commit/7295312c97eed750dd776b4bb0a1a5a86cae4d88>`__
* Fix surface size when rastering rotated SVG symbols (Oliver Tonnhofer) : `dc091b2 <https://github.com/mapserver/mapserver/commit/dc091b232efa00a6a7143e7dff04ac9254b4db78>`__
* Update to new ODBC types SQLLEN and SQLULEN to fix issue  `#5172 <https://github.com/mapserver/mapserver/issues/5172>`__  (Seth Girvin) : `075519a <https://github.com/mapserver/mapserver/commit/075519a91bbf13fe6d74d6caaef77a3bcdaff20c>`__
* Avoid calling msProjectionsDiffer over and over again ( `#5259 <https://github.com/mapserver/mapserver/issues/5259>`__ ) (Thomas Bonfort) : `6acfaf4 <https://github.com/mapserver/mapserver/commit/6acfaf410dfb744340dce83ec918565ad1db5f53>`__
* msOGRWriteFromQuery(): use OSRRelease() instead of OSRDestroySpatialReference() (Even Rouault) : `40c8ffd <https://github.com/mapserver/mapserver/commit/40c8ffddb0a6c9defa05bcf13dd25767c9c8db8b>`__
* Make utfgrid driver use msIO output ( `#5260 <https://github.com/mapserver/mapserver/issues/5260>`__ ) (Thomas Bonfort) : `fb73a05 <https://github.com/mapserver/mapserver/commit/fb73a0509ba19075549ccc8c6dce0acf289b44e0>`__
* Output fid if requested in OGR-output ( `#5207 <https://github.com/mapserver/mapserver/issues/5207>`__ ) (Thomas Bonfort) : `4af7028 <https://github.com/mapserver/mapserver/commit/4af7028c58c23eb9ebd1a1aa4b7ee388ada4333c>`__

.. _changelog-7-0-1:

Changes from 7.0.0 to 7.0.1
===========================

* Oraclespatial: remove filteritem (RFC91) ( `#5229 <https://github.com/mapserver/mapserver/issues/5229>`__ ) (Michael Smith) : `b1604a7 <https://github.com/mapserver/mapserver/commit/b1604a748c6944570a5e5b6d0966d9c1bf1e4920>`__
* Apply dimension filter to tileindex also if present ( `#5209 <https://github.com/mapserver/mapserver/issues/5209>`__ ) (Emanuele Di Giacomo) : `7daec58 <https://github.com/mapserver/mapserver/commit/7daec58ba4651779b458253ce82100fe42ce7f88>`__
* Contour layer: support tileindex and WMS time ( `#5212 <https://github.com/mapserver/mapserver/issues/5212>`__ ) (Even Rouault) : `a752e70 <https://github.com/mapserver/mapserver/commit/a752e7003d161dc5c9e6e7e9ecc91e354948627e>`__
* Change url encoding of spaces from + to %20 ( `#5232 <https://github.com/mapserver/mapserver/issues/5232>`__ ) (Thomas Bonfort) : `b6fb921 <https://github.com/mapserver/mapserver/commit/b6fb9219d7172c464411daf80f88e9f0883be97b>`__
* Fix memory leak when loading FORMATOPTIONS ( `#5149 <https://github.com/mapserver/mapserver/issues/5149>`__ ) (Thomas Bonfort) : `4df5f9f <https://github.com/mapserver/mapserver/commit/4df5f9f11d87078cb853009a26a74a78615b41cc>`__
* Fix compiler warning (Thomas Bonfort) : `b290c44 <https://github.com/mapserver/mapserver/commit/b290c44d5343700d38f49141e7efcb96b6f0ec18>`__
* Fix handling of empty labels when not using labelcache ( `#5142 <https://github.com/mapserver/mapserver/issues/5142>`__ ) (Thomas Bonfort) : `6102a7a <https://github.com/mapserver/mapserver/commit/6102a7a1511f610c96047020693ed8de9f18734c>`__
* Fix labels on mapscript-set postlabelcache layers ( `#5142 <https://github.com/mapserver/mapserver/issues/5142>`__ ) (Thomas Bonfort) : `9523495 <https://github.com/mapserver/mapserver/commit/9523495512cc1e6e73e0901a6b470d4f463cc7ac>`__
* Ignore eventual leading UTF8 BOM ( `#5194 <https://github.com/mapserver/mapserver/issues/5194>`__ ) (Thomas Bonfort) : `e50c067 <https://github.com/mapserver/mapserver/commit/e50c067a1577efc93a01f285e550b4d70e5f0af5>`__
* Fix orientation of "vertex" geomtransform ( `#5213 <https://github.com/mapserver/mapserver/issues/5213>`__ ) (Daniel Morissette) : `9b93019 <https://github.com/mapserver/mapserver/commit/9b93019cb7ad2e86031fa35dc57b5ffcdae8e2ef>`__
* Allow empty items in inline features ( `#5182 <https://github.com/mapserver/mapserver/issues/5182>`__ ) (Thomas Bonfort) : `f404adf <https://github.com/mapserver/mapserver/commit/f404adf6ccc9f38d3774b24ffdfedd9aa0edabf9>`__
* Support GDAL 2.0 64bit integer fields (Even Rouault) : `4238420 <https://github.com/mapserver/mapserver/commit/4238420939197f9a7412dcb9667613028e1a2847>`__
* Correct calls to MAX/MIN to MS_MAX/MS_MIN ( `#5251 <https://github.com/mapserver/mapserver/issues/5251>`__ ) (Sam Jorna) : `f0dedb6 <https://github.com/mapserver/mapserver/commit/f0dedb65992be817c83feba7c9b77cc719aefc71>`__
* Fix mapscript saving of numbers in exp format ( `#5014 <https://github.com/mapserver/mapserver/issues/5014>`__ ) (Thomas Bonfort) : `ed7d3f6 <https://github.com/mapserver/mapserver/commit/ed7d3f63cbed417281864fff66fb568501dd57ac>`__
* OGR output: emit layers with no results ( `#5208 <https://github.com/mapserver/mapserver/issues/5208>`__ ) (Thomas Bonfort) : `1ad47f6 <https://github.com/mapserver/mapserver/commit/1ad47f6bab40772e1fa82eb4bc5d3e018439fd06>`__
* Fixed case when drawing legend shapes with style geomtransforms. ( `#5193 <https://github.com/mapserver/mapserver/issues/5193>`__ ) (Steve Lime) : `4f7d463 <https://github.com/mapserver/mapserver/commit/4f7d463d734cc8c6ad4ecd04cc0dca8cd4ffe371>`__
* Fix format-security errors with swig and java and ruby ( `#5253 <https://github.com/mapserver/mapserver/issues/5253>`__ ) (Julien Enselme) : `90f00f7 <https://github.com/mapserver/mapserver/commit/90f00f77631ee42de9a2efa92807f5ee3254c662>`__
* Fixed label placement computation issue with thin polygons. ( `#5234 <https://github.com/mapserver/mapserver/issues/5234>`__ ) (Steve Lime) : `078a6a3 <https://github.com/mapserver/mapserver/commit/078a6a3dcf652df96acb3759c578d37bdf8bd19d>`__
* Fix compilation error when libxml2 disabled ( `#5249 <https://github.com/mapserver/mapserver/issues/5249>`__ ) (Sam Jorna) : `ab96f8a <https://github.com/mapserver/mapserver/commit/ab96f8a35e0d85ac9a83ec1cb9032ad33afe802b>`__
* Fix list expression handling logic ( `#5245 <https://github.com/mapserver/mapserver/issues/5245>`__ ) (Thomas Bonfort) : `0d71c41 <https://github.com/mapserver/mapserver/commit/0d71c41d2fe86e603f6ab1114b9fedc7f1db5b58>`__
* Fix handling of non-labelcached empty labels ( `#5241 <https://github.com/mapserver/mapserver/issues/5241>`__ ) (Thomas Bonfort) : `9ade01a <https://github.com/mapserver/mapserver/commit/9ade01a09ee896b1bf43d33728acafb67e122f93>`__
* Fix handling of empty labels through mapscript ( `#5240 <https://github.com/mapserver/mapserver/issues/5240>`__ ) (Thomas Bonfort) : `5a83df5 <https://github.com/mapserver/mapserver/commit/5a83df5450b2480b672e99fb42a0e46222ecc0e4>`__
* Fix label rendering from mapscript with labelcache disabled ( `#5239 <https://github.com/mapserver/mapserver/issues/5239>`__ ) (Thomas Bonfort) : `2f3e195 <https://github.com/mapserver/mapserver/commit/2f3e195eaac04ccd494bec97ac84dc00618346c9>`__
* Discard labels outside image extent when using masks ( `#5237 <https://github.com/mapserver/mapserver/issues/5237>`__ ) (Thomas Bonfort) : `4196ac3 <https://github.com/mapserver/mapserver/commit/4196ac38b326ef9dfb03dd62712e7f44928c61f2>`__
* Contour layer: support tileindex and WMS time ( `#5212 <https://github.com/mapserver/mapserver/issues/5212>`__ ) (Even Rouault) : `946c210 <https://github.com/mapserver/mapserver/commit/946c210c2976dde1a2d10152655feaacedfda5cf>`__
* Fix 'shoud' typo, replace with 'should' ( `#5228 <https://github.com/mapserver/mapserver/issues/5228>`__ ) (Bas Couwenberg) : `84c9d79 <https://github.com/mapserver/mapserver/commit/84c9d79a3d70c449d96689a10eb3ab6e13c2e769>`__
* Don't export mapserver target for static libmapserver. ( `#5170 <https://github.com/mapserver/mapserver/issues/5170>`__ ) (Bas Couwenberg) : `d26278d <https://github.com/mapserver/mapserver/commit/d26278dfafd6db7ced6c2fd4e4380777fe888431>`__
* Fix type inconsistencies. (Bas Couwenberg) : `278a280 <https://github.com/mapserver/mapserver/commit/278a280411130f2a0521afb222d7780d2581c816>`__
* Fix segfault on legend rendering with nested layers ( `#4713 <https://github.com/mapserver/mapserver/issues/4713>`__ ) (Thomas Bonfort) : `d02e6fb <https://github.com/mapserver/mapserver/commit/d02e6fb3b168f6977391efcb83886f332d07d01f>`__
* iconv feature attributes before applying filtering ( `#5215 <https://github.com/mapserver/mapserver/issues/5215>`__ ) (Thomas Bonfort) : `100e6af <https://github.com/mapserver/mapserver/commit/100e6af4f2d96ace9d331d054eea3deaf99e5f35>`__
* Contour layer: report error when DATA isn't defined ( `#5212 <https://github.com/mapserver/mapserver/issues/5212>`__ ) (Even Rouault) : `f8ec673 <https://github.com/mapserver/mapserver/commit/f8ec673eb57e7838808206ef38e2f70d28985b9f>`__
* Cleaning up conditional directives that split up parts of statements. (Flavio Medeiros) : `93b80c9 <https://github.com/mapserver/mapserver/commit/93b80c95abae2a65a648a6fd1ac02630ec25ae7b>`__
* Fix hang while rendering text on degenerate polygons ( `#4908 <https://github.com/mapserver/mapserver/issues/4908>`__ ) (Thomas Bonfort) : `3dfc920 <https://github.com/mapserver/mapserver/commit/3dfc920d6892886d925d3449f6eaddb1e6e8bcb6>`__
* Fix build issues with OGR disabled (Thomas Bonfort) : `ab2a612 <https://github.com/mapserver/mapserver/commit/ab2a6129435ca37d02730a6faf85593afa0daf9b>`__
* Fix build without iconv ( `#5195 <https://github.com/mapserver/mapserver/issues/5195>`__ ) (Thomas Bonfort) : `e47e642 <https://github.com/mapserver/mapserver/commit/e47e642a9a905815c14c87636cbfea2d7e63a3ed>`__
* msValidateTimeValue(): reject strings with single quote character to avoid potential SQL injections ( `#3907 <https://github.com/mapserver/mapserver/issues/3907>`__ ) (Even Rouault) : `463d31f <https://github.com/mapserver/mapserver/commit/463d31f44622f6c0908ef87cadf2cb07df35c801>`__
* Fix PHP ms_newGridObj ( `#5159 <https://github.com/mapserver/mapserver/issues/5159>`__ ) (Tamas Szekeres) : `4dacec0 <https://github.com/mapserver/mapserver/commit/4dacec0e256cad4113309dee7855c03f5e32f484>`__
* Added status check after msLayerWhichItems() is called in msDrawVectorLayer(). ( `#5188 <https://github.com/mapserver/mapserver/issues/5188>`__ ) (Steve Lime) : `55f7fc8 <https://github.com/mapserver/mapserver/commit/55f7fc89755854cb95d11334ceb1f76495536ac3>`__
* Mark pixman support as experimental ( `#5181 <https://github.com/mapserver/mapserver/issues/5181>`__ ) (Thomas Bonfort) : `ad25f15 <https://github.com/mapserver/mapserver/commit/ad25f1506e813d0fb3ee0d120ff00da51a4df6dc>`__
* Make pthread return compatible with 64bits checks ( `#5137 <https://github.com/mapserver/mapserver/issues/5137>`__ ) (Bruno Friedmann) : `1d3eb7e <https://github.com/mapserver/mapserver/commit/1d3eb7ef9e6fa8467f618dcb3901403250a3be96>`__
* Fix java mapscript to be compatible with newer swig ( `#5174 <https://github.com/mapserver/mapserver/issues/5174>`__ ) (Bruno Friedmann) : `8399145 <https://github.com/mapserver/mapserver/commit/8399145191c4bf2065ba436a62ca76b776c5bb19>`__
* Update mapaxisorder.h/.csv to EPSG 8.6 database ( `#5168 <https://github.com/mapserver/mapserver/issues/5168>`__ ) (Even Rouault) : `f10f24d <https://github.com/mapserver/mapserver/commit/f10f24df536a84cf20fb7210d29832692ca45c1e>`__
* Avoid infinite loop during labeling with empty text ( `#5167 <https://github.com/mapserver/mapserver/issues/5167>`__ ) (Martin Kofahl) : `c00e84a <https://github.com/mapserver/mapserver/commit/c00e84a36a83d46f6aade94560de9f606dde630b>`__
* Backport master appveyor.yml (Even Rouault) : `effcd44 <https://github.com/mapserver/mapserver/commit/effcd44a4f6d6a6a4d1002ce79bc54c56e136df6>`__
* Don't install mapserver target twice. (Bas Couwenberg) : `3c10ad1 <https://github.com/mapserver/mapserver/commit/3c10ad17cbd04998edf779c92f3be04a9bc3b460>`__
* SLD: support LayerFeatureConstraints/FeatureTypeConstraint/Filter ( `#4025 <https://github.com/mapserver/mapserver/issues/4025>`__ ) (Even Rouault) : `c391b86 <https://github.com/mapserver/mapserver/commit/c391b86b12ba08e52184e5d14e5d7f2b28c0260d>`__
* Install headers and export cmake package for external projects ( `#5119 <https://github.com/mapserver/mapserver/issues/5119>`__ ) (Bas Couwenberg) : `2549b43 <https://github.com/mapserver/mapserver/commit/2549b439c325b37ec8d57a283e7b9601a338d48f>`__
* Correctly initialize "scalebar" utility ( `#5141 <https://github.com/mapserver/mapserver/issues/5141>`__ ) (Thomas Bonfort) : `e5f8b61 <https://github.com/mapserver/mapserver/commit/e5f8b610bf1d9f5e1f2325ac5687aab327b3be01>`__
* Fix xmlmapfile xsd bug for label->scaledenoms ( `#5129 <https://github.com/mapserver/mapserver/issues/5129>`__ ) (Jürgen Weichand) : `f916cad <https://github.com/mapserver/mapserver/commit/f916cad6c6827b086c3718144ebbddc6390651d4>`__
* Fix missing fcloses on failures ( `#5143 <https://github.com/mapserver/mapserver/issues/5143>`__ ) (Sander Jansen) : `de2869b <https://github.com/mapserver/mapserver/commit/de2869bcd8586f618aa4f2078088dc82b3e9136a>`__
* Fix memory AGG and OGR leaks on error ( `#5145 <https://github.com/mapserver/mapserver/issues/5145>`__ ) (Sander Jansen) : `75d092a <https://github.com/mapserver/mapserver/commit/75d092a8eab8b51c72bd27aeb40bc275b312f56d>`__
* Fix memory leaks/errors in mapuvraster.c ( `#5148 <https://github.com/mapserver/mapserver/issues/5148>`__ ) (Sander Jansen) : `d6d3432 <https://github.com/mapserver/mapserver/commit/d6d3432b8892c7898fa62895d8dc7d739fb05e54>`__
* fix memory leak in mapproject.c ( `#5150 <https://github.com/mapserver/mapserver/issues/5150>`__ ) (Sander Jansen) : `433428e <https://github.com/mapserver/mapserver/commit/433428e5f972ecf1c8aba927298b2a1b18a7dc65>`__
* Fix a couple of forgotten msFreeShape in msDrawVectorLayer ( `#5151 <https://github.com/mapserver/mapserver/issues/5151>`__ ) (Sander Jansen) : `8cf63dc <https://github.com/mapserver/mapserver/commit/8cf63dcc98dac135a0ae4875ba5feaa015bc4a67>`__
* Fix leak in msWMSPrepareNestedGroups ( `#5152 <https://github.com/mapserver/mapserver/issues/5152>`__ ) (Sander Jansen) : `1b08236 <https://github.com/mapserver/mapserver/commit/1b08236298701d52b1b997ef712b897086276bae>`__
* remove stray debugging message ( `#5139 <https://github.com/mapserver/mapserver/issues/5139>`__ ) (Thomas Bonfort) : `8b44188 <https://github.com/mapserver/mapserver/commit/8b4418890263d8dcd7a7c44222f5daf4253b9a73>`__
* Fixed a bug (see  `#5157 <https://github.com/mapserver/mapserver/issues/5157>`__ ) where converting points from pixel to image coordinates with the shpxy tag was happening twice. (Steve Lime) : `aad6de3 <https://github.com/mapserver/mapserver/commit/aad6de36da54d7ae9a77f8b820a200ec3ae012e6>`__
* Fixed a bug (see  `#5157 <https://github.com/mapserver/mapserver/issues/5157>`__ ) where converting points from pixel to image coordinates with the shpxy tag was happening twice. (Steve Lime) : `c8f813d <https://github.com/mapserver/mapserver/commit/c8f813d43e0e08699d207572cab3a7312b831dc6>`__
* WFS OGR output: fix creation of .zip with MIF files ( `#5155 <https://github.com/mapserver/mapserver/issues/5155>`__ ) (Even Rouault) : `901499d <https://github.com/mapserver/mapserver/commit/901499dd59e37a7fdbcc443f3f645e13abc99015>`__
* Update SetRGB arguments in csharp sample (Tamas Szekeres) : `6ec760c <https://github.com/mapserver/mapserver/commit/6ec760c918b1e418d71fb1bd63c7068cf9a520f7>`__
* Fix compilation with gif_lib 5.1 (Sander Jansen) : `3e76491 <https://github.com/mapserver/mapserver/commit/3e76491eafeb3f4d573f40fe7699656347882393>`__
* WCS: GeoTIFF creation option is TILED, not TILING (Even Rouault) : `bff33fb <https://github.com/mapserver/mapserver/commit/bff33fbcf2c108a9b1ca426056414b4df6aa076b>`__
* handle the case where include_dirs is set in distutils.cfg (Tomasz Pajor) : `f6805a1 <https://github.com/mapserver/mapserver/commit/f6805a1771e8c2daadb33d07ca0a7dcb940ea342>`__

.. _changelog-7-0-0:

Changes from 7.0.0-beta2 to 7.0.0
=================================

* Oraclespatial: Fix IEQ expression translation ( `#5124 <https://github.com/mapserver/mapserver/issues/5124>`__ ) (Michael Smith) : `f67fbaf <https://github.com/mapserver/mapserver/commit/f67fbaf6a02706ce278f1d24273d819049b89dbb>`__
* fix compiler warnings ( `#5122 <https://github.com/mapserver/mapserver/issues/5122>`__ ) (Thomas Bonfort) : `960a9b1 <https://github.com/mapserver/mapserver/commit/960a9b192328ac9cf63e0b76d2fc75a39dd7a8a2>`__
* Refactor changes in Mapscript colorObj to optional arguments (ejn) : `d7c26bc <https://github.com/mapserver/mapserver/commit/d7c26bcd686bf251a046e3ef4f61b8f623eca663>`__
* MapScript colorObj SWIG/PHP alignment and methods with alpha (ejn) : `025ffe1 <https://github.com/mapserver/mapserver/commit/025ffe147a977041e5d5c6960c3a48645bbb24e3>`__
* Allow access to layer [metadata_*] tags in legacy headers & footers (ejn) : `e945d25 <https://github.com/mapserver/mapserver/commit/e945d2547146cc109ef8753cd2e7b4d186f6be3b>`__
* Typo in fribidi description ( `#5091 <https://github.com/mapserver/mapserver/issues/5091>`__ ) (Thomas Bonfort) : `9cf3889 <https://github.com/mapserver/mapserver/commit/9cf388998d693953c856e2d4c10396ab2dc1912b>`__
* Bump SOVERSION to 2 to account for removed symbols since 6.4. (Bas Couwenberg) : `5154eb8 <https://github.com/mapserver/mapserver/commit/5154eb8dbf63de9b952504c2b9cc47ec65e43532>`__
* fix incorrect rounding/casting when scaling label outlinewidth ( `#5107 <https://github.com/mapserver/mapserver/issues/5107>`__ ) (Thomas Bonfort) : `135997a <https://github.com/mapserver/mapserver/commit/135997a686326a46030b08ce1d58e1a4a3de08b7>`__
* Fix handling time literals in msMSSQL2008LayerTranslateFilter (Tamas Szekeres) : `982f3e6 <https://github.com/mapserver/mapserver/commit/982f3e618b5a5839bcf19b4f71b1b1763029e8f6>`__
* Avoid including header files inside an extern C block ( `#5117 <https://github.com/mapserver/mapserver/issues/5117>`__ ) (Thomas Bonfort) : `1754752 <https://github.com/mapserver/mapserver/commit/175475278c712e0c297dc8c04c5e7d32d23865ab>`__
* Fix 'Unkown' typo, replace with 'Unknown'. (Bas Couwenberg) : `bf8c0f7 <https://github.com/mapserver/mapserver/commit/bf8c0f7baa47f42be8eaa1bf45717371dbce7b2d>`__
* Fix 'consistant' typo, replace with 'consistent'. (Bas Couwenberg) : `5f3554c <https://github.com/mapserver/mapserver/commit/5f3554c3e6726b1ddf63e41301b69d1f7707734a>`__

.. _changelog-7-0-0-beta2:

Changes from 7.0.0-beta1 to 7.0.0-beta2
=======================================

* Prevent XML external entities from being fetched with libxml2 < 2.9.0 (Even Rouault) : `6600f47 <https://github.com/mapserver/mapserver/commit/6600f475495e3d5cd8819fae3490150e8a66404f>`__
* Avoid potential recursion problem in msSHPLayerNextShape(). ( `#5108 <https://github.com/mapserver/mapserver/issues/5108>`__ ) (Steve Lime) : `7efdf9c <https://github.com/mapserver/mapserver/commit/7efdf9c9e33823b487405b63e571961785b9f29a>`__
* FLTGetIsBetweenComparisonCommonExpresssion(): use appropriate backquote escaping for Date fields ( `#5104 <https://github.com/mapserver/mapserver/issues/5104>`__ ) (Even Rouault) : `b1b97aa <https://github.com/mapserver/mapserver/commit/b1b97aa1675822dfcfb45969953dc91b67c785e6>`__
* FLTIsNumeric(): fix so that values like 2004-12-01 aren't recognized as numeric on Linux ( `#5104 <https://github.com/mapserver/mapserver/issues/5104>`__ ) (Even Rouault) : `a2d862d <https://github.com/mapserver/mapserver/commit/a2d862d2d0d86dec926573a4ec9ffcba809d3de9>`__
* Use explicit PROCESSING FORCE_DRAW_LABEL_CACHE=FLUSH to keep room for future options ( `#5100 <https://github.com/mapserver/mapserver/issues/5100>`__ ) (Daniel Morissette) : `e39aae5 <https://github.com/mapserver/mapserver/commit/e39aae5e81000324afea9abae4788426ab4bfdb4>`__
* Add PROCESSING FORCE_DRAW_LABEL_CACHE layer-level option (Daniel Morissette) : `729fa9c <https://github.com/mapserver/mapserver/commit/729fa9c4a1ab84c2a774756f681add2235a07e11>`__
* Fix memory error + leak in fontface cache ( `#4794 <https://github.com/mapserver/mapserver/issues/4794>`__ ) (Thomas Bonfort) : `6b982bb <https://github.com/mapserver/mapserver/commit/6b982bbf822c720061a22963baed409afcf8a8cf>`__
* MSSQL: Update time filter vtable function (Tamas Szekeres) : `61592a7 <https://github.com/mapserver/mapserver/commit/61592a7413e473f05bf974412b29bcae7abdbc24>`__
* Fix handling time literals in msMSSQL2008LayerTranslateFilter (Tamas Szekeres) : `2020c2c <https://github.com/mapserver/mapserver/commit/2020c2c207c24ee33db7480004f34d0fd72e60a5>`__
* Implement msMSSQL2008LayerTranslateFilter ( `#4974 <https://github.com/mapserver/mapserver/issues/4974>`__ ) (Tamas Szekeres) : `ad0aa44 <https://github.com/mapserver/mapserver/commit/ad0aa441f10b4622bb7818e328392a3d5c98341a>`__
* Fix copyVirtualTable to copy all vtable elements (Tamas Szekeres) : `c613db0 <https://github.com/mapserver/mapserver/commit/c613db00c4860c428e4078f5d630fa2c947f37e3>`__
* Cleanup. (Fabian Schindler) : `b5feb64 <https://github.com/mapserver/mapserver/commit/b5feb643baeb51a160e9eb255760fb5376e9761f>`__
* Addressing  `#5047 <https://github.com/mapserver/mapserver/issues/5047>`__ : the coverages CRS is now the default subsettingCrs rather than imageCRS. (Fabian Schindler) : `bb63909 <https://github.com/mapserver/mapserver/commit/bb63909281ea574d48396dfcece5873e76881c40>`__
* FLTGetBinaryComparisonCommonExpression(): escape date literals with backquote ( `#5104 <https://github.com/mapserver/mapserver/issues/5104>`__ ) (Even Rouault) : `b7a7339 <https://github.com/mapserver/mapserver/commit/b7a7339363483c009096992f1e64668561e7a124>`__
* Applied patch for  `#5099 <https://github.com/mapserver/mapserver/issues/5099>`__ ... (Steve Lime) : `933c1f5 <https://github.com/mapserver/mapserver/commit/933c1f5ad758e05e99d68b5f75f43fa25da1aad4>`__
* Fix segfault in PHP MapScript implementation of saveQuery with results parameter set. (Martin Kofahl) : `eb9e5a4 <https://github.com/mapserver/mapserver/commit/eb9e5a43a7fad78855a84cfbbdb8e2efbcd25f5a>`__
* This patch is to fix the issue "GetCapabilities request is extremely slow when “OWS_LAYER_GROUP” is used" (aabhayas) : `134fcf7 <https://github.com/mapserver/mapserver/commit/134fcf79faf0458e45751f1b3410600bdfd12e5e>`__
* Prevent buffer overflow with raster queries with more than 4 bands (Daniel Morissette) : `02dacd9 <https://github.com/mapserver/mapserver/commit/02dacd9658aba913671545a6ebb8fe532bdb2a1d>`__
* Fix segfault on TTF symbols smaller than 1 pixel ( `#5086 <https://github.com/mapserver/mapserver/issues/5086>`__ ) (Thomas Bonfort) : `29bbefa <https://github.com/mapserver/mapserver/commit/29bbefa308ea45a0df2c9d588cce98aeb5832b1d>`__
* Removed double free in WFS layer ( `#5085 <https://github.com/mapserver/mapserver/issues/5085>`__ ) (Martin Kofahl) : `9da77c1 <https://github.com/mapserver/mapserver/commit/9da77c11f7e6ab1265a6a0bcf9975d6c8e3a5841>`__
* Correct scaling of label outline ( `#4942 <https://github.com/mapserver/mapserver/issues/4942>`__ ) (Thomas Bonfort) : `d0043f2 <https://github.com/mapserver/mapserver/commit/d0043f27538ff70c7911fa22707d4839ccfeae80>`__
* Fix bounds calculation for the MSSQL driver ( `#5082 <https://github.com/mapserver/mapserver/issues/5082>`__ ) (Tamas Szekeres) : `3e7ecf7 <https://github.com/mapserver/mapserver/commit/3e7ecf7d1ca3512c6c66f30ebed739cdd484a841>`__
* Removing GD-COPYING since the GD dependency has been removed. ( `#5080 <https://github.com/mapserver/mapserver/issues/5080>`__ ) (Steve Lime) : `890808f <https://github.com/mapserver/mapserver/commit/890808f347c6f89600212e19a0d168a974fea26f>`__
* fix ANCHORPOINT not written on map->save ( `#5073 <https://github.com/mapserver/mapserver/issues/5073>`__ ) (Thomas Bonfort) : `a5ce205 <https://github.com/mapserver/mapserver/commit/a5ce205492e019873a25fd51630e6dc851dec133>`__
* Removing gd from installed packages. (Stephan Meissl) : `cba7ccf <https://github.com/mapserver/mapserver/commit/cba7ccf9097c1f2a33160ef4803edd6a817d5939>`__
* Add support for outlinewidth in legend icons ( `#5064 <https://github.com/mapserver/mapserver/issues/5064>`__ ) (Daniel Morissette) : `537b40f <https://github.com/mapserver/mapserver/commit/537b40f910c8d7ebdd4e83c8ccf5b3c973f5f3b9>`__


.. _changelog-7-0-0-beta1:

Changes from 6.4 to 7.0.0-beta1
=================================


* Remove the ArcSDE C API driver from MapServer ( `#5067 <https://github.com/mapserver/mapserver/issues/5067>`__ ) (Howard Butler) : `936518bac <https://github.com/mapserver/mapserver/commit/936518bac4b6ed449d9883c36f1fd01ebfd70c2d>`__
* fix typo and undeclared functions related to RFC113 ( `#5071 <https://github.com/mapserver/mapserver/issues/5071>`__ ) (Thomas Bonfort) : `2ec8d06 <https://github.com/mapserver/mapserver/commit/2ec8d06300edc8d1694479f96655ee0db8a2ebb6>`__
* Correcting and harmonizing exceptionCode and locator usage in WCS ( `#4388 <https://github.com/mapserver/mapserver/issues/4388>`__ ). (Stephan Meissl) : `c37b3bc <https://github.com/mapserver/mapserver/commit/c37b3bc66091b84bdfd9259fc8e11d79b91882b3>`__
* Add support for RFC91 processing option NATIVE_FILTER to oracle driver ( `#5001 <https://github.com/mapserver/mapserver/issues/5001>`__ ) (Michael Smith) : `1842327 <https://github.com/mapserver/mapserver/commit/184232738a1ca868ec811a2ec16ce4b9d449ae8d>`__
* Implement RFC-113 Layer Compositing Framework ( `#5071 <https://github.com/mapserver/mapserver/issues/5071>`__ ) (Thomas Bonfort) : `29db335 <https://github.com/mapserver/mapserver/commit/29db335114606f3564e81f3c706f137efdfb3fb2>`__
* Reduce UTF grid size by removing unused entries ( `#5002 <https://github.com/mapserver/mapserver/issues/5002>`__ ) (Francois Blackburn) : `f152773 <https://github.com/mapserver/mapserver/commit/f15277340681a2b573d2e7e0b55ef0f4a79440ed>`__
* When WFS changes the map->projection, also project the default map->extent ( `#5065 <https://github.com/mapserver/mapserver/issues/5065>`__ ) (Michael Smith) : `cf065f3 <https://github.com/mapserver/mapserver/commit/cf065f3e71fb23ab1cd6e8a65d50e530bbf33e15>`__
* Fix NULL pointer dereference in mapdraw.c ( `#5069 <https://github.com/mapserver/mapserver/issues/5069>`__ ) (aeichner) : `1fdcb04 <https://github.com/mapserver/mapserver/commit/1fdcb04767b700424dbadd60dac75dda6cf78304>`__
* RFC109: allow substitutions from env vars and in processing entries ( `#4877 <https://github.com/mapserver/mapserver/issues/4877>`__ ) (Thomas Bonfort) : `65bce48 <https://github.com/mapserver/mapserver/commit/65bce48b645e46911342263531d94dc5bcec2b17>`__
* Removed unused function... (Steve Lime) : `6d4c425 <https://github.com/mapserver/mapserver/commit/6d4c425e29a0ca7bb3b353064014d835912a413a>`__
* jsonp support (Andreas Eichner) : `76c8c66 <https://github.com/mapserver/mapserver/commit/76c8c66f7c3f27c626fd07013e415a43e7f0f904>`__
* Add missing max/minScaleDenom to xld/t files (Abdelkader Boudih) : `f79aacc <https://github.com/mapserver/mapserver/commit/f79aacc39fcd302f924dacba5c8faf1f4e8103aa>`__
* Evaluate a possibly set environment variable PROJ_LIB ( `#4930 <https://github.com/mapserver/mapserver/issues/4930>`__ ). (Martin Kofahl) : `e17e69b <https://github.com/mapserver/mapserver/commit/e17e69ba1567869e935cabeee51b5f2bc71cac14>`__
* Adding missing implemented RFCs to HISTORY.TXT (Stephan Meissl) : `6c72159 <https://github.com/mapserver/mapserver/commit/6c7215964a88e13630649816ad6b2d092ba88d38>`__
* Move filter translation into msLayerWhichShapes() and out of the draw/query functions. (Steve Lime) : `a42c38a <https://github.com/mapserver/mapserver/commit/a42c38a7dd9d749f3e20c978b1d716714a217e5f>`__
* OGR cannot handle common filters directly, return MS_FALSE... (sdlime) : `f9e5d1f <https://github.com/mapserver/mapserver/commit/f9e5d1fe4accae657e0274ed99d3f1eccc04770e>`__
* Ignore the return status from filter translation. Let MapServer handle cases where translation fails. (sdlime) : `2e3fce1 <https://github.com/mapserver/mapserver/commit/2e3fce1000e313164af6d2f859d5d654984cc264>`__
* Updated OGR driver for ticket  `#5001 <https://github.com/mapserver/mapserver/issues/5001>`__ . Quite a large change actually... (Steve Lime) : `0a48731 <https://github.com/mapserver/mapserver/commit/0a48731eeda16af3b276be11c92cbb151400a83e>`__
* remove too verbose error messages in oracle and postgis drivers ( `#4928 <https://github.com/mapserver/mapserver/issues/4928>`__ ) (Thomas Bonfort) : `9f7f14f <https://github.com/mapserver/mapserver/commit/9f7f14f5bfb2be794e5b39960623e2b2cb23a8ef>`__
* Updated SDE driver for issue  `#5001 <https://github.com/mapserver/mapserver/issues/5001>`__ . (Steve Lime) : `0866a76 <https://github.com/mapserver/mapserver/commit/0866a76606f240e9d3561b89baa27ae010699765>`__
* Updated MS SQLServer driver to work off the NATIVE_FILTER processing key ( `#5001 <https://github.com/mapserver/mapserver/issues/5001>`__ ). (Steve Lime) : `b16b23d <https://github.com/mapserver/mapserver/commit/b16b23d6b8c664099695cc8356d1cdb5f180abc9>`__
* Fixed last of the known RFC 91 issues. Had to remove end-of-line regex anchors in time format patterns. (Steve Lime) : `0c110a1 <https://github.com/mapserver/mapserver/commit/0c110a1cb1a9b235509141c259a0f3a9783220da>`__
* Update symbol references in labelcache when removing a symbol ( `#4656 <https://github.com/mapserver/mapserver/issues/4656>`__ ) (Tamas Szekeres) : `8ffb75c <https://github.com/mapserver/mapserver/commit/8ffb75cbfc02123f443647d8dc2d9f88ef9ba053>`__
* Convert OGR curve geometry to linear geometry (GDAL >= 2.0) (Even Rouault) : `92289a7 <https://github.com/mapserver/mapserver/commit/92289a70da63489332506e4b1e2e784e56dc0d19>`__
* Fix builds with Visual Studio 2013 ( `#5059 <https://github.com/mapserver/mapserver/issues/5059>`__ ) (Tamas Szekeres) : `0efde12 <https://github.com/mapserver/mapserver/commit/0efde125bedf154d1dde5fcf21324d930f0fea74>`__
* Fix builds with Visual Studio 2013 ( `#5059 <https://github.com/mapserver/mapserver/issues/5059>`__ ) (Tamas Szekeres) : `1e5e76d <https://github.com/mapserver/mapserver/commit/1e5e76d97c7f80f4da59dd7292cc9bed25d07cf6>`__
* Fix security exception for the MSVC2010+ compilers ( `#3438 <https://github.com/mapserver/mapserver/issues/3438>`__ ) (Tamas Szekeres) : `ae6806f <https://github.com/mapserver/mapserver/commit/ae6806fcb0fb33a244b3eec14019e7c32d10b21b>`__
* Fix security exception for the MSVC2010+ compilers ( `#3438 <https://github.com/mapserver/mapserver/issues/3438>`__ ) (Tamas Szekeres) : `c951bd6 <https://github.com/mapserver/mapserver/commit/c951bd6b5e0193f5b28231ad8cf3b7725de18db7>`__
* Add support for Oracle Spatial 12.1 ( `#4901 <https://github.com/mapserver/mapserver/issues/4901>`__ ) (Tamas Szekeres) : `d6baeb5 <https://github.com/mapserver/mapserver/commit/d6baeb5b6d2ed5599d50bff143f84a7ae6dc9255>`__
* Add support for Oracle Spatial 12.1 ( `#4901 <https://github.com/mapserver/mapserver/issues/4901>`__ ) (Tamas Szekeres) : `624eded <https://github.com/mapserver/mapserver/commit/624eded30a8bff1c9d15a4b3e20933c3c5212323>`__
* Return list of supported versions in WCS GetCapabilities. Fixes  `#5046 <https://github.com/mapserver/mapserver/issues/5046>`__ . (Stephan Meissl) : `bf27d13 <https://github.com/mapserver/mapserver/commit/bf27d130f16172f9731565be107e17e72636e059>`__
* Added a check to msFreeCharArray() to bail if the array itself is NULL. (Steve Lime) : `1985e2b <https://github.com/mapserver/mapserver/commit/1985e2bb3a4e0d82313fb6d2a85f0a6f4a089bc3>`__
* Added a check to msFreeCharArray() to bail if the array itself is NULL. (Steve Lime) : `278f347 <https://github.com/mapserver/mapserver/commit/278f34747911e093960388ba50a568fff914c9ac>`__
* JPEG output: enable optimized coding (Even Rouault) : `9b6b7db <https://github.com/mapserver/mapserver/commit/9b6b7dbefa8fb53300c31edef36d9c3546b96449>`__
* Correct issue  `#4992 <https://github.com/mapserver/mapserver/issues/4992>`__  : DATARANGE serialization type invalid (geonux) : `b3801c4 <https://github.com/mapserver/mapserver/commit/b3801c433a655f8401ea0dc981d598da2a31901b>`__
* msResampleGDALToMap(): optimizations for tiled queries (Even Rouault) : `5a22ae7 <https://github.com/mapserver/mapserver/commit/5a22ae7b4f10f3e6b93e6ba842bc90d21a5ae1b9>`__
* msProjectionsDiffer(): use proj4 string normalization (Even Rouault) : `eeb1e78 <https://github.com/mapserver/mapserver/commit/eeb1e786a36e594ae8133f7a6d5b127175894952>`__
* msWCSSetFormatParams20(): correctly pair msFree() with msMalloc() (Even Rouault) : `6f1b34a <https://github.com/mapserver/mapserver/commit/6f1b34af594788d2885e659517d3377fc1cc5ef6>`__
* correct floating point format for SLD Gap/InitialGap (Thomas Bonfort) : `8c3dc41 <https://github.com/mapserver/mapserver/commit/8c3dc41d946579ded63e99a107419f4215a0d7f4>`__
* Add Gap/InitialGap to SLD GraphicStroke (Thomas Bonfort) : `a616107 <https://github.com/mapserver/mapserver/commit/a61610736bc63ab9cb79d04829d2319b506ef8bd>`__
* Added : as a permissible character in URL variable strings ( `#5039 <https://github.com/mapserver/mapserver/issues/5039>`__ ) (Steve Lime) : `20f4c13 <https://github.com/mapserver/mapserver/commit/20f4c13b4f91459b5b1b965b3a28e49928b1ece4>`__
* Implement order by option for the mssql driver ( `#5008 <https://github.com/mapserver/mapserver/issues/5008>`__ ) (Tamas Szekeres) : `e653b9b <https://github.com/mapserver/mapserver/commit/e653b9b01aa5267e3f13cfddc2ea2558bccdb15e>`__
* Addressed ticket  `#5032 <https://github.com/mapserver/mapserver/issues/5032>`__  by forcing code that writes a range to produce a MapServer expression only... (Steve Lime) : `fa230a6 <https://github.com/mapserver/mapserver/commit/fa230a6144542d38eec144a64c3b87638537e9cc>`__
* Fix for the OGR autostyle unit calculation ( `#5028 <https://github.com/mapserver/mapserver/issues/5028>`__ ) (Tamas Szekeres) : `e5eb628 <https://github.com/mapserver/mapserver/commit/e5eb628908adfec32f64a04ced223e13258f93b1>`__
* msLayoutTextSymbol(): fix memory corruption in case of failed iconv() ( `#5025 <https://github.com/mapserver/mapserver/issues/5025>`__ ) (Even Rouault) : `5b2c46a <https://github.com/mapserver/mapserver/commit/5b2c46a24aef5d44c6d88add909d4d646fc10c15>`__
* Fix wrong use of iconv() that caused encoded_text pointer to be moved and corrupted ( `#5025 <https://github.com/mapserver/mapserver/issues/5025>`__ ) (Even Rouault) : `084be4d <https://github.com/mapserver/mapserver/commit/084be4dd2b697e36cee1c804a8cb1298e334fcd2>`__
* Remove default translation behavior that sets filter->native_string since filters are MapServer expressions only. (sdlime) : `d330457 <https://github.com/mapserver/mapserver/commit/d330457c6a06d32604803a391bb1674f5226c97d>`__
* Simplified msQueryByFilter() since FILTERs can *only* be MapServer expressions. ( `#5001 <https://github.com/mapserver/mapserver/issues/5001>`__ ) (sdlime) : `c11e13a <https://github.com/mapserver/mapserver/commit/c11e13a7177b11642c13e373047f2ec83e0c1405>`__
* Removed translation check for native SQL. (sdlime) : `b1c383b <https://github.com/mapserver/mapserver/commit/b1c383b189baf010f182c8daf5423a4a1e5712a4>`__
* Added support for NATIVE_FILTER processing key to PostGIS driver. (sdlime) : `1451ed4 <https://github.com/mapserver/mapserver/commit/1451ed4bb04e379a9a46fee3fafe670802c48e38>`__
* Fix crash on CONNECTIONTYPE kerneldensity on Windows ( `#5019 <https://github.com/mapserver/mapserver/issues/5019>`__ ) (Even Rouault) : `b762546 <https://github.com/mapserver/mapserver/commit/b7625467ceb952421d6c936dcaca251c60d9e9a2>`__
* Remove atexit() call on Win32 code path that cause crashes on mapserv (Even Rouault) : `403f110 <https://github.com/mapserver/mapserver/commit/403f1100da19d302dae1cc869ce25915e10749a6>`__
* Fix crash when copying a map with label leaders (Paul Spencer) : `2f200c0 <https://github.com/mapserver/mapserver/commit/2f200c083601c33b70c015d21ad13fa0579e072f>`__
* Added default outputformats which fixes missing default formats when only the ServiceMetadata section is requested. (Fabian Schindler) : `8dab0b6 <https://github.com/mapserver/mapserver/commit/8dab0b617f832170ce18b196e24e417161fc9924>`__
* Add missing dll export (Tamas Szekeres) : `77fe033 <https://github.com/mapserver/mapserver/commit/77fe033fb01348fd784aaf20adbb751ff2f47cc9>`__
* Add comment to mention that MS_ENABLE_CGI_CL_DEBUG_ARGS is disabled because of security concerns (Even Rouault) : `8e1e90a <https://github.com/mapserver/mapserver/commit/8e1e90a4cd04b45e2feaf67d8f945faa4bbd0ba9>`__
* Extend default message displayed when launching mapserv without argument, to advertize --help (Even Rouault) : `95bc4e2 <https://github.com/mapserver/mapserver/commit/95bc4e2fa9dd94761d2878b0bdb89762aceb55cf>`__
* Add -h/--help option to mapserv binary to display help message (Even Rouault) : `592f3eb <https://github.com/mapserver/mapserver/commit/592f3eb23d77e81cfb681e42ed0022f9c7d872c1>`__
* Remove MS_HTTP_HEADER hack to use mapserv -nh existing mechanism (Even Rouault) : `a10b31b <https://github.com/mapserver/mapserver/commit/a10b31ba5fb9e45654b7980fa8d76f76ea25c8da>`__
* Improve previous commit when msIO_setHeader() is called before any call to msIO_Initialize() (Even Rouault) : `e262f0e <https://github.com/mapserver/mapserver/commit/e262f0e77f50a3af8685edf5837d44468a2a47ae>`__
* For debugging: add env. variable MS_HTTP_HEADER that can be set to NO in the non-MOD_WMS_ENABLED mode to avoid emitting HTTP headers (Even Rouault) : `fba3bec <https://github.com/mapserver/mapserver/commit/fba3bec786ba208c31c0ecebba0a64e87a8d9209>`__
* add missing entries to label copies (Thomas Bonfort) : `41067b4 <https://github.com/mapserver/mapserver/commit/41067b4793cb5d38748080b9ea632d2e1ff3a4ab>`__
* OGR style: handle multiple combined tool and support 'l' (priority level) ( `#4982 <https://github.com/mapserver/mapserver/issues/4982>`__ ,  `#4983 <https://github.com/mapserver/mapserver/issues/4983>`__ ) (Even Rouault) : `8ea07be <https://github.com/mapserver/mapserver/commit/8ea07bec91297652ba94828d3bfd0216a621c8e9>`__
* msOGRUpdateStyle(): split it in 4 subfunctions. No functional change (Even Rouault) : `5ffa2f2 <https://github.com/mapserver/mapserver/commit/5ffa2f2b993a5a645ffc75949d1a7434a32ba733>`__
* OGR style: support more options for Pen and Brush ( `#4982 <https://github.com/mapserver/mapserver/issues/4982>`__ ,  `#4983 <https://github.com/mapserver/mapserver/issues/4983>`__ ) (Even Rouault) : `18ef92d <https://github.com/mapserver/mapserver/commit/18ef92da99f3a91e1c3bccad883a8050a026e730>`__
* writeMap(): Adding ANGLE to directives saved (Pierre Mauduit) : `6ab6088 <https://github.com/mapserver/mapserver/commit/6ab60889ccf232a6dfbb9a9da94e176af31f7de4>`__
* Fix segfault when no overlap in kerneldensity layers ( `#4857 <https://github.com/mapserver/mapserver/issues/4857>`__ ) (Thomas Bonfort) : `5bfaf9b <https://github.com/mapserver/mapserver/commit/5bfaf9b54d81b2dd106fa61c541716e788192f28>`__
* Fix post RFC91 issues in mapogcsld.c ( `#4974 <https://github.com/mapserver/mapserver/issues/4974>`__ ) (Even Rouault) : `eeaf85b <https://github.com/mapserver/mapserver/commit/eeaf85b33e22599b78c9a8e022a91dc56d34be2a>`__
* msContourLayerGenerateContour(): fix crash with GDAL trunk (Even Rouault) : `28d8be3 <https://github.com/mapserver/mapserver/commit/28d8be35ba42dca9a64bb5240ddd744c64cf6caa>`__
* Fix regression of previous commit in ogr_multi_defer.png and ogr_attrfilter.png ( `#4974 <https://github.com/mapserver/mapserver/issues/4974>`__ ,  `#4999 <https://github.com/mapserver/mapserver/issues/4999>`__ ) (Even Rouault) : `6a4d00e <https://github.com/mapserver/mapserver/commit/6a4d00ed0b40cfc6e17356df065ba8b5c43b1b64>`__
* msOGRFileWhichShapes(): fix taking into account of filters ( `#4974 <https://github.com/mapserver/mapserver/issues/4974>`__ ) (Even Rouault) : `6902603 <https://github.com/mapserver/mapserver/commit/6902603d719c6aa2bc630b1f8cb40827d70d992f>`__
* FLTGetSpatialComparisonCommonExpression(): use polygon instead of rectangle ( `#4974 <https://github.com/mapserver/mapserver/issues/4974>`__ ) (Even Rouault) : `6bde3f8 <https://github.com/mapserver/mapserver/commit/6bde3f817ad0221b119e12dc47509a04a4fe8fbe>`__
* msPostGISLayerTranslateFilter: fix memory leak (Even Rouault) : `50ce97c <https://github.com/mapserver/mapserver/commit/50ce97c3a805cd03248e809d808e8f685cc62c2e>`__
* don't evaluate filter expression before geometry has been setup ( `#4974 <https://github.com/mapserver/mapserver/issues/4974>`__ , `#4995 <https://github.com/mapserver/mapserver/issues/4995>`__ ) (Thomas Bonfort) : `fcda97a <https://github.com/mapserver/mapserver/commit/fcda97a22a2a2630a09c684a77948a404a8ea75e>`__
* Follow simple equality and range work done pre-7.0/RFC 91. (sdlime) : `edbbf0f <https://github.com/mapserver/mapserver/commit/edbbf0ffbb922b61523c4016da77c38177d9e8d1>`__
* RFC91/postgis explicitly cast string bindings to text ( `#4974 <https://github.com/mapserver/mapserver/issues/4974>`__ ) (Thomas Bonfort) : `648ec49 <https://github.com/mapserver/mapserver/commit/648ec499bdc90ed05855a1cefa0d9641e70e46cc>`__
* Adjusted call to misspelled time API function name. (sdlime) : `2e99414 <https://github.com/mapserver/mapserver/commit/2e99414eff0584b07d76ca6cc80ff55ecbfcd18b>`__
* Changed date/time patterns to have end-of-line anchors ($). Fixed a misspelling in one of the time API function names. (sdlime) : `0cc47e3 <https://github.com/mapserver/mapserver/commit/0cc47e3027a75cf18c5310694877999c6b245371>`__
* Use bounding-box specific reprojection code ( `#4974 <https://github.com/mapserver/mapserver/issues/4974>`__ ) (Thomas Bonfort) : `2d312c5 <https://github.com/mapserver/mapserver/commit/2d312c54a6a3c752b4dab6dd9c2d06bc8724660c>`__
* Fix wrong un-premultiplication with bilinear resampler with non-opaque input ( `#4993 <https://github.com/mapserver/mapserver/issues/4993>`__ ) (Even Rouault) : `1e94cc0 <https://github.com/mapserver/mapserver/commit/1e94cc0dd1011126a6ec9fbb53ab5f807d4850c3>`__
* Avoid explicit casts on date/time columns. (sdlime) : `8f149eb <https://github.com/mapserver/mapserver/commit/8f149eb372e65490fcbaa631456c15154c993b07>`__
* WFS: take correctly into account XML comments in filters ( `#4986 <https://github.com/mapserver/mapserver/issues/4986>`__ ) (Even Rouault) : `26f5630 <https://github.com/mapserver/mapserver/commit/26f563084c21a069effe6fc02147000f00007ffc>`__
* Fixed PostGIS translation for time-only date/time handling (fixes wms_time_pattern_12_13_test_postgis.map tests). (sdlime) : `e386d0b <https://github.com/mapserver/mapserver/commit/e386d0b7e03703bc10f01f5d55404de2a0134966>`__
* WFS: fix parsing of filters with parenthesis ( `#4986 <https://github.com/mapserver/mapserver/issues/4986>`__ ) (Even Rouault) : `f2a817c <https://github.com/mapserver/mapserver/commit/f2a817cd85099648dbf5e9349667b9f78861764f>`__
* Fixing the unresolved reference for the oracle plugin build ( `#4985 <https://github.com/mapserver/mapserver/issues/4985>`__ ) (Tamas Szekeres) : `43597da <https://github.com/mapserver/mapserver/commit/43597da79d61ff221986317622714f820f327750>`__
* For data sources with inconsistent row numbers, queryByIndex should not set a resultindex.  `#4926 <https://github.com/mapserver/mapserver/issues/4926>`__   `#4076 <https://github.com/mapserver/mapserver/issues/4076>`__  (Martin Kofahl) : `500860a <https://github.com/mapserver/mapserver/commit/500860a68004229ad772d1c08e184c6a4dbf97e7>`__
* Added a few comments to clarify projection handling. (sdlime) : `6508b7e <https://github.com/mapserver/mapserver/commit/6508b7e1d4c2407537b126fc21b93f074ad17275>`__
* Added filter translation check to msQueryByRect(). (sdlime) : `54b5169 <https://github.com/mapserver/mapserver/commit/54b5169a39985aabce9c4f50560942a9c10c21f7>`__
* Add <ogc:PropertyName></ogc:PropertyName> tags in SLD label ( `#4921 <https://github.com/mapserver/mapserver/issues/4921>`__ ) (Yves Jacolin) : `d2867f7 <https://github.com/mapserver/mapserver/commit/d2867f7943a321096a4007e5f791cf30f9db044e>`__
* Use X-FORWARDED-* headers when constructing onlineresource ( `#4955 <https://github.com/mapserver/mapserver/issues/4955>`__ ) (Thomas Bonfort) : `3241921 <https://github.com/mapserver/mapserver/commit/3241921a5d52b34c3d93b6f0b88f82779de27f26>`__
* Better support of the simple features profile (Stéphane Brunner) : `5d433c6 <https://github.com/mapserver/mapserver/commit/5d433c68c961c2e04a7fe383b2a46021a9e56e1b>`__
* Fixed hour and minute translation templates. (sdlime) : `69e62e4 <https://github.com/mapserver/mapserver/commit/69e62e488a6bad866b5a82c27af601a1cba9c003>`__
* RFC91: Support for Oracle Spatial filtering ( `#4974 <https://github.com/mapserver/mapserver/issues/4974>`__ ) (Michael Smith) : `d4fe121 <https://github.com/mapserver/mapserver/commit/d4fe1214c9c2ae653d2cf3afcb586cc51882e981>`__
* Implement RFC91 Layer Filter Normalization ( `#4974 <https://github.com/mapserver/mapserver/issues/4974>`__ ) (Steve Lime) : `9991eed <https://github.com/mapserver/mapserver/commit/9991eedbf1171ed75aa703101b41b882e910d1b7>`__
* Update CMakeLists.txt (Jackey Cheung) : `f6c6230 <https://github.com/mapserver/mapserver/commit/f6c62303114219e72fbbdcf4327f1816fbde4b8a>`__
* Force going through the resampler in client WMS receiving a clipped BBOX ( `#4931 <https://github.com/mapserver/mapserver/issues/4931>`__ ) (Thomas Bonfort) : `529e26e <https://github.com/mapserver/mapserver/commit/529e26e2bf7f79cd0a7c709a62789699e9047653>`__
* use execute_process instead of exec_program in FindAPACHE.cmake ( `#4948 <https://github.com/mapserver/mapserver/issues/4948>`__ ) (Ezequiel Lara Gómez) : `644d750 <https://github.com/mapserver/mapserver/commit/644d750edf3a128775c271ec53250a470fa7c768>`__
* Don't treat OGR autostyle'd text as a mapserver expression ( `#4965 <https://github.com/mapserver/mapserver/issues/4965>`__ ) (Thomas Bonfort) : `e841969 <https://github.com/mapserver/mapserver/commit/e841969e8b306d73dc9e657c7c1982a748802e9f>`__
* fix segfault when computing degenerate line lengths ( `#4972 <https://github.com/mapserver/mapserver/issues/4972>`__ ) (Thomas Bonfort) : `e5c2e65 <https://github.com/mapserver/mapserver/commit/e5c2e65dc01f030790dea394f81c814e2d468cb4>`__
* Fix overflow in integer calculations ( `#4970 <https://github.com/mapserver/mapserver/issues/4970>`__ ) (Tamas Szekeres) : `fcd7cf3 <https://github.com/mapserver/mapserver/commit/fcd7cf3a15d256dc96e4f0dd914dd2ae08a66596>`__
* Fixed the typo in resetClassStyle ( `#4971 <https://github.com/mapserver/mapserver/issues/4971>`__ ) (Tamas Szekeres) : `ac1bc49 <https://github.com/mapserver/mapserver/commit/ac1bc492df94670383ed61634789671885e6577a>`__
* Fix an issue with the complex polygon in oracle (dufop) : `46849f4 <https://github.com/mapserver/mapserver/commit/46849f44f67a62e3d8e3eb656b32f2aebe1c050f>`__
* Fix issue in error count ( `#4960 <https://github.com/mapserver/mapserver/issues/4960>`__ ) (Tamas Szekeres) : `cc9625e <https://github.com/mapserver/mapserver/commit/cc9625e2b1c27af029f5c39498dd67ab78c56015>`__
* Adding a more descriptive message in case of multiple error occurrence ( `#4960 <https://github.com/mapserver/mapserver/issues/4960>`__ ) (Tamas Szekeres) : `2a3ec0a <https://github.com/mapserver/mapserver/commit/2a3ec0a65a3694ce89fc0bb0b9f6fee71d6ae7da>`__
* Break potential infinite loop in msProjectSegment ( `#4961 <https://github.com/mapserver/mapserver/issues/4961>`__ ) (Tamas Szekeres) : `54dda8c <https://github.com/mapserver/mapserver/commit/54dda8c1adbc4a423d0f10706e6ee0502b1c04f4>`__
* Hiding large number of errors in msSetError ( `#4960 <https://github.com/mapserver/mapserver/issues/4960>`__ ) (Tamas Szekeres) : `8d8f22f <https://github.com/mapserver/mapserver/commit/8d8f22f4fdcfd61696e34209cbbe9ed9998423e8>`__
* Python mapscript : fix setting pattern on mapscript.styleObj ( `#4943 <https://github.com/mapserver/mapserver/issues/4943>`__ ) (Even Rouault) : `3e8aa5a <https://github.com/mapserver/mapserver/commit/3e8aa5a4d92c9bad105306ebe5117ed29d2b0e7c>`__
* Fix illegal use of stack-allocated objects in maprendering (Pierre Mauduit) : `f7772c3 <https://github.com/mapserver/mapserver/commit/f7772c36c39e28fe4e53d6632aedcc32c542877c>`__
* #define GEOS_USE_ONLY_R_API to avoid accidental use of non reentrant GEOS API (Even Rouault) : `0c573e4 <https://github.com/mapserver/mapserver/commit/0c573e45783477e8fb8aa2a3a8cbe565dd67836c>`__
* OGR output: add wfs_additional_files_in_output layer/web metadata item ( `#4884 <https://github.com/mapserver/mapserver/issues/4884>`__ ) (Even Rouault) : `cd83f45 <https://github.com/mapserver/mapserver/commit/cd83f4513f22431522b29c2270bff529e1e1fa5d>`__
* OGR output (zip form): when we have FORMATOPTION "FILENAME=basename.ext.zip", use basename.ext as the name of the OGR datasource ( `#4933 <https://github.com/mapserver/mapserver/issues/4933>`__ ) (Even Rouault) : `0ba8257 <https://github.com/mapserver/mapserver/commit/0ba82572c5a63cbf6961cf79406c174dacd7253a>`__
* PostGIS input: fix regression introduced by 62d3e61 when dealing with 2D-only PostGIS 1.X geometries ( `#4941 <https://github.com/mapserver/mapserver/issues/4941>`__ ) (Even Rouault) : `f2acfb4 <https://github.com/mapserver/mapserver/commit/f2acfb46525a7dcb8d8a53744f29071d026e0e4d>`__
* GML output: export XYZ when USE_POINT_Z_M is defined and gml_geomtype is set to Point25D/LineString25D/etc.. (same syntax as 2.5D OGR output) (Even Rouault) : `5e6489e <https://github.com/mapserver/mapserver/commit/5e6489ebd42bef9315a8c7f70479a2a823b473bf>`__
* OGR output: fix export of line geometry as MultiPoint (Even Rouault) : `edc64a6 <https://github.com/mapserver/mapserver/commit/edc64a6881f03a5e576956031ee0e397b46d5da4>`__
* PostGIS input: add 2.5D support when USE_POINT_Z_M is defined (Even Rouault) : `62d3e61 <https://github.com/mapserver/mapserver/commit/62d3e6146bc1b446965dbbaf36afb6377cd0d1cf>`__
* OGR input: add 2.5D support when USE_POINT_Z_M is defined (Even Rouault) : `4630612 <https://github.com/mapserver/mapserver/commit/4630612e421ae9cfbdef11892f002e257380897b>`__
* Fix undeclared symbols in maputil.c (Paul Spencer) : `8e85fce <https://github.com/mapserver/mapserver/commit/8e85fce4b15d098983b7758c80a60d9afee0cd40>`__
* Fix syntax error (Paul Spencer) : `4f6eb6c <https://github.com/mapserver/mapserver/commit/4f6eb6c48f58a5a4c9a9864b80622a730ed1a8e6>`__
* Update mapwfs.c (mathieudugal) : `7a5c1d6 <https://github.com/mapserver/mapserver/commit/7a5c1d6ab27be9b183eeaf0f571083dd03c7e1d9>`__
* Support xs:int for WFS feature properties. (mathieudugal) : `5a3d2b4 <https://github.com/mapserver/mapserver/commit/5a3d2b414a038b7469a527e73c5ca058b202dfa0>`__
* Fix previous commit with GDAL version < 1.10 ( `#4858 <https://github.com/mapserver/mapserver/issues/4858>`__ ) (Even Rouault) : `5beb10e <https://github.com/mapserver/mapserver/commit/5beb10e1ecfefbaee03e462fd1f7043dee8db934>`__
* Make 'stream' OGR output compatible with FCGI with GDAL >= 2.0 ( `#4858 <https://github.com/mapserver/mapserver/issues/4858>`__ ) (Even Rouault) : `2c5aad9 <https://github.com/mapserver/mapserver/commit/2c5aad92a1e441fea8b08e38c995f8c3f831473a>`__
* WFS: Make GetFeature with a FEATUREID/RESOURCEID parameter work if the layer name contains a dot ( `#4925 <https://github.com/mapserver/mapserver/issues/4925>`__ ) (Even Rouault) : `ad68998 <https://github.com/mapserver/mapserver/commit/ad6899883755ac74502b8cd459a463ff07f69120>`__
* Modify the graticule layer to store settings in a custom object instead of layerinfo ( `#4913 <https://github.com/mapserver/mapserver/issues/4913>`__ ) (Tamas Szekeres) : `a5348b8 <https://github.com/mapserver/mapserver/commit/a5348b86b0b0c180ac0ae890747f7d1b3279ec23>`__
* Use php://input instead of raw_post_data to support PHP 5.6. (Bas Couwenberg) : `fc99472 <https://github.com/mapserver/mapserver/commit/fc99472b8b2fc837148f71755f23349a71e307bf>`__
* Fix failing repeated FOLLOW labels when maxoverlap is triggered ( `#4910 <https://github.com/mapserver/mapserver/issues/4910>`__ ) (Thomas Bonfort) : `793bd36 <https://github.com/mapserver/mapserver/commit/793bd369d8bd193485a12456d789b8ef7a1ee716>`__
* tweak installed packages (Thomas Bonfort) : `cc34484 <https://github.com/mapserver/mapserver/commit/cc34484d91609326dff830daef03bad39fc02b0d>`__
* Fix segfault when setting a utfitem not present ( `#4904 <https://github.com/mapserver/mapserver/issues/4904>`__ ) (Even Rouault) : `eef2a3d <https://github.com/mapserver/mapserver/commit/eef2a3d164d25d59fd5dc907b5297faa1667abc3>`__
* Implement WCS20 Extensions ( `#4898 <https://github.com/mapserver/mapserver/issues/4898>`__ ) (Fabian Schindler) : `d246a0b <https://github.com/mapserver/mapserver/commit/d246a0b41c2f94674859e9332c22341e9581b1b0>`__
* add missing check for  `#4899 <https://github.com/mapserver/mapserver/issues/4899>`__  (Thomas Bonfort) : `75a5408 <https://github.com/mapserver/mapserver/commit/75a540818262cc7a005b05bee50b5f109a63bef5>`__
* Fix failed assertion with non-existant svg symbols ( `#4899 <https://github.com/mapserver/mapserver/issues/4899>`__ ) (Francois Blackburn) : `83e4ee8 <https://github.com/mapserver/mapserver/commit/83e4ee86a5415644b0ab10472f03cc2d239c6268>`__
* Allow AGG images bigger than 2 GB ( `#4421 <https://github.com/mapserver/mapserver/issues/4421>`__ ) (Even Rouault) : `344e7de <https://github.com/mapserver/mapserver/commit/344e7de3eb984eec7705eab0faf166298b6da626>`__
* Don't apply scalefactor on legend keyimage ( `#4885 <https://github.com/mapserver/mapserver/issues/4885>`__ ) (Thomas Bonfort) : `7b86158 <https://github.com/mapserver/mapserver/commit/7b861585744c01fabdf374d60a39b2e42f7af5f1>`__
* Fix dateline wrapping logic for bounding boxes ( `#4896 <https://github.com/mapserver/mapserver/issues/4896>`__ ) (Thomas Bonfort) : `46a4fea <https://github.com/mapserver/mapserver/commit/46a4feaa752bae2cab14f38d8411ac87da387087>`__
* mapfile.c: don't redefine _GNU_SOURCE (Max Kellermann) : `079f816 <https://github.com/mapserver/mapserver/commit/079f8161c35f1c98675a5d2ac9349380798678e0>`__
* remove NULL checks before free() (Max Kellermann) : `9b4b819 <https://github.com/mapserver/mapserver/commit/9b4b819cf3a6b2f4923828f83477d5ffd87f540e>`__
* simplify SfRealloc() (Max Kellermann) : `3e2964c <https://github.com/mapserver/mapserver/commit/3e2964ccfaa00489112992616f7efe091b0046f2>`__
* mapxbase: make DBFIsValueNULL() static (Max Kellermann) : `e151854 <https://github.com/mapserver/mapserver/commit/e15185413bfbda57efbbb2033932a7c0b6bddcdb>`__
* const-correctness (Max Kellermann) : `c69d113 <https://github.com/mapserver/mapserver/commit/c69d113b21f26b5d45cf40e672c3bf1a71507f7f>`__
* 99c0e8b is not needed ( `#4758 <https://github.com/mapserver/mapserver/issues/4758>`__ ) (Thomas Bonfort) : `77313de <https://github.com/mapserver/mapserver/commit/77313de827e85e6239f5ee9a0214a3b599468412>`__
* add RFC103 layer encoding setter/getter to swig ( `#4758 <https://github.com/mapserver/mapserver/issues/4758>`__ ) (Thomas Bonfort) : `99c0e8b <https://github.com/mapserver/mapserver/commit/99c0e8b47df5c673f9bdf12ce0b64d937029e322>`__
* Rename predefined field names for cluster and union layers ( `#4082 <https://github.com/mapserver/mapserver/issues/4082>`__ ) (Tamas Szekeres) : `794cdcc <https://github.com/mapserver/mapserver/commit/794cdcc64620d2c1958bfede5ec1c5424c0592de>`__
* Fix SDE plugin build ( `#4887 <https://github.com/mapserver/mapserver/issues/4887>`__ ) (Tamas Szekeres) : `a78ef93 <https://github.com/mapserver/mapserver/commit/a78ef9336349276ad8b9e683af0364efb29562a3>`__
* Require Validation of SLD ExternalGraphic OnlineResource ( `#4883 <https://github.com/mapserver/mapserver/issues/4883>`__ ) (Luigi Pirelli) : `e184249 <https://github.com/mapserver/mapserver/commit/e18424940d5c48391c61cf62b0bda883805bc871>`__
* fixups after coverity merge (Thomas Bonfort) : `35b226c <https://github.com/mapserver/mapserver/commit/35b226c8b5d2cd81e73ab25026bdb3ab70330988>`__
* Fixing a large number of programming errors found by static analysis (Thomas Bonfort) : `55a5688 <https://github.com/mapserver/mapserver/commit/55a568814e701339aa72c3366802ca615a59c64b>`__
* UTFGRID: implement escaping of item and data values (Even Rouault) : `673ad22 <https://github.com/mapserver/mapserver/commit/673ad22cd4227a8a1f96ab6cf6a044c62549e827>`__
* WFS 2.0: generate correct MetadataURL element, and add optional wfs_metadataurl_about layer metadata item ( `#4886 <https://github.com/mapserver/mapserver/issues/4886>`__ ) (Even Rouault) : `f4b969d <https://github.com/mapserver/mapserver/commit/f4b969d25d263ef88a676441bdc1d938a2b9df94>`__
* avoid numerous error messages for failed runtime substitutions ( `#4877 <https://github.com/mapserver/mapserver/issues/4877>`__ ) (Thomas Bonfort) : `09598ea <https://github.com/mapserver/mapserver/commit/09598ea7e92a9dbef6cc5b3e2ecb8bec2919b3ad>`__
* RFC109: fix infinite loop on metadata substitutions ( `#4877 <https://github.com/mapserver/mapserver/issues/4877>`__ ) (Thomas Bonfort) : `99db0ee <https://github.com/mapserver/mapserver/commit/99db0ee47fc69d75d5548e059bf19904de7b9e36>`__
* add forgotten class substitutions of rfc019 ( `#4877 <https://github.com/mapserver/mapserver/issues/4877>`__ ) (Thomas Bonfort) : `f0e0117 <https://github.com/mapserver/mapserver/commit/f0e011780e69d3db180ddcb59bbbaaf1fd9a2bc4>`__
* add missing map reference to image (Zak James) : `814286d <https://github.com/mapserver/mapserver/commit/814286deddf85f4c9829619c2af617fc862cb02b>`__
* Switch off ogr-output streaming mode for non default io contexts ( `#4858 <https://github.com/mapserver/mapserver/issues/4858>`__ ) (Thomas Bonfort) : `3d174b4 <https://github.com/mapserver/mapserver/commit/3d174b45a2d9809edb674971c3b620ded2d28d50>`__
* Restore lexer file pointer on INCLUDE error ( `#4871 <https://github.com/mapserver/mapserver/issues/4871>`__ ) (Thomas Bonfort) : `74f9382 <https://github.com/mapserver/mapserver/commit/74f93828d4e411c8226da09aefd501ddd39bfa35>`__
* RFC109: Refactor Application of Runtime Substitutions ( `#4877 <https://github.com/mapserver/mapserver/issues/4877>`__ ) (Thomas Bonfort) : `c4542bc <https://github.com/mapserver/mapserver/commit/c4542bc4c120bd03727dbcb21b3164f64aedb767>`__
* WFS SortBy support for OGR layers: include WHERE clause (when available) to speed-up queries since OGR SQLite driver does not yet support fast attribute filter on SELECT result layers ( `#4878 <https://github.com/mapserver/mapserver/issues/4878>`__ ) (Even Rouault) : `1c30b21 <https://github.com/mapserver/mapserver/commit/1c30b21b7f5affa789dd9846c859d2e4ccb336da>`__
* Fix WFS SortBy support for OGR layers ( `#4878 <https://github.com/mapserver/mapserver/issues/4878>`__ ) (Even Rouault) : `05c1a77 <https://github.com/mapserver/mapserver/commit/05c1a777c0165f77d6c2c09e6b25c49b42397e6d>`__
* Fix blending of semi-opaque pixels in average and bilinear resamplers ( `#4875 <https://github.com/mapserver/mapserver/issues/4875>`__ ) (Thomas Bonfort) : `fa29db4 <https://github.com/mapserver/mapserver/commit/fa29db4bb2b9a60d46a2c24ab67c48efbb3642f3>`__
* Require validation for CGI queryfile parameter ( `#4874 <https://github.com/mapserver/mapserver/issues/4874>`__ ). (Steve Lime) : `88ec351 <https://github.com/mapserver/mapserver/commit/88ec351fe7c085d544e8190ebb0bb809d8082ac9>`__
* Allow map->projection inheritance for layers referenced by connection ( `#4873 <https://github.com/mapserver/mapserver/issues/4873>`__ ) (Thomas Bonfort) : `05ff84f <https://github.com/mapserver/mapserver/commit/05ff84f136afd3a578fff59f4f99f31a7a4e6212>`__
* msOGRFileClose: drop useless OGR mutex that could cause a dead-lock with tileindex ( `#4869 <https://github.com/mapserver/mapserver/issues/4869>`__ ) (Even Rouault) : `51f98b0 <https://github.com/mapserver/mapserver/commit/51f98b05aae13d2548fd534f20ff7309d737da89>`__
* msOGRFileClose: drop useless OGR mutex that could cause a dead-lock with tileindex ( `#4869 <https://github.com/mapserver/mapserver/issues/4869>`__ ) (Even Rouault) : `bab4738 <https://github.com/mapserver/mapserver/commit/bab4738bc6e1826a00aca09d375d3aa5c0c01513>`__
* Implement RFC108 heatmap support ( `#4857 <https://github.com/mapserver/mapserver/issues/4857>`__ ) (Thomas Bonfort) : `6676cea <https://github.com/mapserver/mapserver/commit/6676cea7031d1fbff17cc92c2d32e71cebede678>`__
* Adjusting INSPIRE WMS 1.1.1 capabilities. Fixes  `#4861 <https://github.com/mapserver/mapserver/issues/4861>`__ . (Stephan Meissl) : `b49c847 <https://github.com/mapserver/mapserver/commit/b49c8476f525c6b83b91c3252b9ca9872427a830>`__
* Escape backslashes in the mapfile string writer ( `#4747 <https://github.com/mapserver/mapserver/issues/4747>`__ ) (Tamas Szekeres) : `94ca8b7 <https://github.com/mapserver/mapserver/commit/94ca8b7284aa5196a9389b3168f3d8e6452b0dc5>`__
* Fix non-default harfbuzz configuration logic ( `#4848 <https://github.com/mapserver/mapserver/issues/4848>`__ ) (Thomas Bonfort) : `ff83a55 <https://github.com/mapserver/mapserver/commit/ff83a55d4fa3ffa40d18807576d6c986b8a60b4b>`__
* WFS 1.1/2.0: fix warning message when layer name is invalid to expand '%s' to layer name (Even Rouault) : `7035017 <https://github.com/mapserver/mapserver/commit/70350179589cc8a2102e5736d11ecb233e4fa02f>`__
* add SVG_INCLUDE_DIR so that svg.h is found (cnieman) : `baef2ec <https://github.com/mapserver/mapserver/commit/baef2eca91edc496f50354a3586925af8973d511>`__
* Fix angle follow calculation on vertical or horizontal lines ( `#4839 <https://github.com/mapserver/mapserver/issues/4839>`__ ) (Thomas Bonfort) : `a9dce78 <https://github.com/mapserver/mapserver/commit/a9dce78359a1eedb3f3f5b370a27b50492bef9fc>`__
* avoid erroneous error condition on too short lines ( `#4838 <https://github.com/mapserver/mapserver/issues/4838>`__ ) (Thomas Bonfort) : `036f18a <https://github.com/mapserver/mapserver/commit/036f18accb4881df208f620249aac77f2948f630>`__
* Fix non-labelcache'd drawing of line and polygon labels ( `#4837 <https://github.com/mapserver/mapserver/issues/4837>`__ ) (Thomas Bonfort) : `e52b4b5 <https://github.com/mapserver/mapserver/commit/e52b4b5ec9c35b8a02085e6c20c1f046ba5aca97>`__
* Don't clear the original feature attributes for the clustered shapes ( `#4666 <https://github.com/mapserver/mapserver/issues/4666>`__ ) (Tamas Szekeres) : `898ab8b <https://github.com/mapserver/mapserver/commit/898ab8b944a6340b5a8742fe12d3aee6ca236e88>`__
* WFS-2 specific fixes for postgis time sql injections ( `#4834 <https://github.com/mapserver/mapserver/issues/4834>`__ , `#4815 <https://github.com/mapserver/mapserver/issues/4815>`__ ) (Thomas Bonfort) : `bb574ee <https://github.com/mapserver/mapserver/commit/bb574ee126c46b9b991ae22806181af1c091348e>`__
* Fix potential SQL Injection with postgis TIME filters ( `#4834 <https://github.com/mapserver/mapserver/issues/4834>`__ ) (Even Rouault) : `3a10f6b <https://github.com/mapserver/mapserver/commit/3a10f6b829297dae63492a8c63385044bc6953ed>`__
* Add .bundle suffix to Ruby module on Mac ( `#4826 <https://github.com/mapserver/mapserver/issues/4826>`__ ) (Larry Shaffer) : `5f0a88f <https://github.com/mapserver/mapserver/commit/5f0a88ffa2202334eef5fc49ff3a0fb02f81cd01>`__
* Update cmake modules for Mac (Larry Shaffer) : `30621f8 <https://github.com/mapserver/mapserver/commit/30621f87dbb7b3260775ce21a05ad3da74f32ac8>`__
* fix parser when V8 mapscript disabled ( `#4827 <https://github.com/mapserver/mapserver/issues/4827>`__ ) (Thomas Bonfort) : `f9cfa79 <https://github.com/mapserver/mapserver/commit/f9cfa79648215351ea2c416fa4488ea4aa1bc91d>`__
* revert commit of a generated file ( `#4827 <https://github.com/mapserver/mapserver/issues/4827>`__ ) (Thomas Bonfort) : `4b7565e <https://github.com/mapserver/mapserver/commit/4b7565e7ef1c861cda075ff63268512032c0a08d>`__
* Fixing segfault when coverage rendering failed. (Fabian Schindler) : `c39c276 <https://github.com/mapserver/mapserver/commit/c39c276cdf25c9c95d5e8ca55abb205165b4eae0>`__
* Added shape type constants (Alan Boudreault) : `0bca059 <https://github.com/mapserver/mapserver/commit/0bca0590793dd4bcc8e75cdfd882ca08059f2b4f>`__
* Implement msPostGISLayerGetExtent ( `#3585 <https://github.com/mapserver/mapserver/issues/3585>`__ ) (Tamas Szekeres) : `ebae992 <https://github.com/mapserver/mapserver/commit/ebae99266bf33824a0216c50697248902f08feb1>`__
* Clustering enhancements ( `#4822 <https://github.com/mapserver/mapserver/issues/4822>`__ ) (Tamas Szekeres) : `02d9b44 <https://github.com/mapserver/mapserver/commit/02d9b4409fa8c9f728340a552195d0e19cafee13>`__
* Added missing include directory for v8 mapscript (root) : `e8063b9 <https://github.com/mapserver/mapserver/commit/e8063b9b8861033a34f2b2f0d730110081d027bb>`__
* Updated lexer and parser (Alan Boudreault) : `f8e1d89 <https://github.com/mapserver/mapserver/commit/f8e1d89214ad764b5725c23520b7353fb5d2ed21>`__
* Update INSTALL.CMAKE (Tom Kralidis) : `1e6ef43 <https://github.com/mapserver/mapserver/commit/1e6ef4322c94303549cf9d7a8add1cff90f5dad9>`__
* revert change (Tom Kralidis) : `da7b523 <https://github.com/mapserver/mapserver/commit/da7b5239bec766c3ead4c1c0286fcd9ed29a4791>`__
* Update INSTALL.CMAKE (Tom Kralidis) : `ffb7874 <https://github.com/mapserver/mapserver/commit/ffb787484187b20189e44f2ee36047e91940c7b7>`__
* Update INSTALL.CMAKE (Tom Kralidis) : `3ed5486 <https://github.com/mapserver/mapserver/commit/3ed5486b52b70a47772af156ba9b93fe7eb57316>`__
* Fix error report when we call a function (Alan Boudreault) : `5c14d51 <https://github.com/mapserver/mapserver/commit/5c14d516338617c6fd1db42a8e396a82dde84fae>`__
* Implementation of RFC 106: Support of Geomtransform JavaScript Plugin (Alan Boudreault) : `c465f6c <https://github.com/mapserver/mapserver/commit/c465f6c1f8be312221642c70466ae0738322ad49>`__
* Applied (backport) patch for  `#4810 <https://github.com/mapserver/mapserver/issues/4810>`__  to mapfile.c. (Steve Lime) : `21d8aed <https://github.com/mapserver/mapserver/commit/21d8aedc1ed3854667cd29c113b374486fb53d9e>`__
* Allows floating point NoData/NULLVALUEs for floating point images. (George Chang) : `339e007 <https://github.com/mapserver/mapserver/commit/339e007e8a3ce7ca70bdad8c33e06074b0ef5f69>`__
* WFS: fix LIKE with backslash as escape character, with Postgis backend (Even Rouault) : `9696348 <https://github.com/mapserver/mapserver/commit/969634889d075c7313fbaf3574128410b0bd7b11>`__
* WFS: Make parsing of gml_optional_items and gml_mandatory_items symmetrical (Even Rouault) : `275ecce <https://github.com/mapserver/mapserver/commit/275eccec0726d7d908838fa53170917499c17c4c>`__
* WFS: make WFS 2.0 GetFeature on multiple layers compliant with 11.3.3.5 (one FeatureCollection for each layer as a wfs:member of the main FeatureCollection) (Even Rouault) : `9edae04 <https://github.com/mapserver/mapserver/commit/9edae04816a68303482d7a8f92a271f7aae7dc53>`__
* Allows floating point NoData/NULLVALUEs for floating point images. (George Chang) : `b7cb571 <https://github.com/mapserver/mapserver/commit/b7cb5712b6bcdb23b2aa8214207bfd2feff50465>`__
* fix segfault on legends with keyimage ( `#4808 <https://github.com/mapserver/mapserver/issues/4808>`__ ) (Thomas Bonfort) : `bdaf0cc <https://github.com/mapserver/mapserver/commit/bdaf0cce11db95c4b9007556142c8c5b4a30424a>`__
* WFS: ask for 1 extra feature (when possible) to be able to know if there are next features (Even Rouault) : `a95dc04 <https://github.com/mapserver/mapserver/commit/a95dc046c36df63cd4074b983df0f800df2596c3>`__
* WFS: fix PropertyIsNull on gml:boundedBy (Even Rouault) : `7c97d94 <https://github.com/mapserver/mapserver/commit/7c97d948645e3c04228e25ba2f5333f0a23fd128>`__
* WFS: make CITE WFS 2.0-r11 pass by making PropertyIsNil work on gml:boundedBy (Even Rouault) : `0b5aae8 <https://github.com/mapserver/mapserver/commit/0b5aae87fcbbe6a87151611693bbc41f74f387b3>`__
* Update mapfile.c (takinwang) : `75f548e <https://github.com/mapserver/mapserver/commit/75f548e77e1f9c7945d677ccee621b93ee0208f1>`__
* WFS: fix PropertyIsNull on gml:name (Even Rouault) : `d67bdb3 <https://github.com/mapserver/mapserver/commit/d67bdb330c9a1333f65db09ea96624a89c00fead>`__
* WFS 2.0: various fixes and enhancements to pass wfs-2.0-r12-SNAPSHOT CITE tests (Simple WFS and Basic WFS conformance levels) (Even Rouault) : `346268e <https://github.com/mapserver/mapserver/commit/346268e9e4700ae64bb3b0b1d2472115289bd9ec>`__
* WFS: implements SortBy (Even Rouault) : `df08e5b <https://github.com/mapserver/mapserver/commit/df08e5be2b9c04ecddc0d5036ecf2cf97f50943e>`__
* WFS: add support for During time filtering (Even Rouault) : `796f951 <https://github.com/mapserver/mapserver/commit/796f95195672528ff20cb219ce930365e329cbae>`__
* WFS: deal with multiple <Query> in a stored query (Even Rouault) : `3b092a3 <https://github.com/mapserver/mapserver/commit/3b092a3832c3618da9c947f3eeba6031a1c800b1>`__
* WFS: use 'srsname' locator instead of 'typename' when issuing an exception about the SRSNAME parameter (Even Rouault) : `f8bc861 <https://github.com/mapserver/mapserver/commit/f8bc861abeaa07ffefbef43dbe93dd719e125db2>`__
* Centralize OWS exceptionCode values as #define and use them in WFS server implementaton (Even Rouault) : `ae61d9c <https://github.com/mapserver/mapserver/commit/ae61d9ca1a7ba0e76c57e6353299d7189bf6fd7f>`__
* Filter: support BBOX without PropertyName, as allowed since FE 1.1.0 (Even Rouault) : `2d6042e <https://github.com/mapserver/mapserver/commit/2d6042e19dac86037d9ea654da27eb15a00ca6d6>`__
* WFS: fix segfault when issuing GetFeature on a layer that can't be opened (Even Rouault) : `dc7f35c <https://github.com/mapserver/mapserver/commit/dc7f35c9735f3adad636969f8cc9e3b62de5d6b3>`__
* Fix compilation and warning problems when disabling libxml2 and/or OGR (Even Rouault) : `6a5935d <https://github.com/mapserver/mapserver/commit/6a5935d49bd557f56a01aa27a442187692c48f60>`__
* WFS 2.0: implement stored queries; also fix maximum feature count support for GetFeature involving filters or featureid (Even Rouault) : `68be3a0 <https://github.com/mapserver/mapserver/commit/68be3a0ef0f1016a500e5349405575372547da98>`__
* use version specific postgis force2d function ( `#4803 <https://github.com/mapserver/mapserver/issues/4803>`__ ) (Thomas Bonfort) : `d4d3e22 <https://github.com/mapserver/mapserver/commit/d4d3e2205eeadd3f4b2ad60d803aa7c1836d8dee>`__
* use st_force2d instead of deprecated st_force_2d ( `#4803 <https://github.com/mapserver/mapserver/issues/4803>`__ ) (Thomas Bonfort) : `3a6fa42 <https://github.com/mapserver/mapserver/commit/3a6fa42289cad3596ccb2437167d7de5b0265f75>`__
* Fix segfault when GetFeature on a invalid typename on a multi-layer map (Even Rouault) : `fb393d6 <https://github.com/mapserver/mapserver/commit/fb393d6b41258f95ac18d7752d54adeee695baa1>`__
* Make label expressions consistent with class expressions by allowing them to work off an item (labelitem). (Steve Lime) : `92a1cac <https://github.com/mapserver/mapserver/commit/92a1cac6f2362bae44985ffe0ada77822fa0eb5e>`__
* Make label expressions consistent with class expressions by allowing them to work off an item (labelitem). (Steve Lime) : `a93fa60 <https://github.com/mapserver/mapserver/commit/a93fa607174c4958ae5a5be2f7e173a449765ef2>`__
* WFS: add support for PropertyName/ValueReference/Filter parameters in gml_groups (Even Rouault) : `7c7fdcf <https://github.com/mapserver/mapserver/commit/7c7fdcf300157bc78d00e0f1e7a38a2bbfcffd18>`__
* WFS 2.0: implement GetPropertyValue request (Even Rouault) : `598e223 <https://github.com/mapserver/mapserver/commit/598e2234c0fd777ba626c2b20029f3e8e822432c>`__
* WFS: fix  `#3319 <https://github.com/mapserver/mapserver/issues/3319>`__  (optional/mandatory attributes by introducing gml_optional_items, gml_mandatory_items and gml_default_items) and  `#3563 <https://github.com/mapserver/mapserver/issues/3563>`__  (PropertyName should check gml_include_items/gml_exclude_items) (Even Rouault) : `b511b24 <https://github.com/mapserver/mapserver/commit/b511b24b31b4ebe2310d4223242ed2fc7bed23c6>`__
* Add support for FE 2.0, and sanitize filter support, particularly related to SRS handling (Even Rouault) : `9e04abb <https://github.com/mapserver/mapserver/commit/9e04abb6af1b24f94c9aeac38d7fd1121fea0fd2>`__
* Implement Inspire extensions for WFS 2.0 (Even Rouault) : `9fd134b <https://github.com/mapserver/mapserver/commit/9fd134b3defedfcadd39f4f713c1d11c73d9e27e>`__
* Fix SLD PerpendicularOffset for lines and labels ( `#4801 <https://github.com/mapserver/mapserver/issues/4801>`__ ) (Thomas Bonfort) : `1d8b68a <https://github.com/mapserver/mapserver/commit/1d8b68afc9b41ba5a76acc4e43c48eb80d224dbb>`__
* Fix ms cmake build (Tamas Szekeres) : `be590fa <https://github.com/mapserver/mapserver/commit/be590fa441fc201253ac9461961527c65fc7c881>`__
* Fix csharp builds for MSVC71 (Tamas Szekeres) : `996fc9d <https://github.com/mapserver/mapserver/commit/996fc9d60dfffccf4e9cfad70ff2e9a4eba8e7d2>`__
* Install python-lxml (Even Rouault) : `1333c5b <https://github.com/mapserver/mapserver/commit/1333c5b25df529d4908654aab17fe770dd4b3e06>`__
* Initial wfs2 commit with GetCapabilities, DescribeFeatureType and GetFeature/GML3.2 support (Even Rouault) : `562796a <https://github.com/mapserver/mapserver/commit/562796a4a4c81b792f7c048389daf35060ee1143>`__
* WFS: use correct XSD datatypes in DescribeFeatureType response ( `#4800 <https://github.com/mapserver/mapserver/issues/4800>`__ ) (Even Rouault) : `dd059f5 <https://github.com/mapserver/mapserver/commit/dd059f572ce18a32a7aa995a1c25f35b1e99e9f9>`__
* WFS: use correct XSD datatypes in DescribeFeatureType response ( `#4800 <https://github.com/mapserver/mapserver/issues/4800>`__ ) (Even Rouault) : `ffe3aec <https://github.com/mapserver/mapserver/commit/ffe3aecd0d24021b5fe6b30f580da7450f85fe8c>`__
* update cmake options and documentation ( `#4784 <https://github.com/mapserver/mapserver/issues/4784>`__ ) (Thomas Bonfort) : `ee905b5 <https://github.com/mapserver/mapserver/commit/ee905b503e397e12ebf37d6f7970764dfcc1f610>`__
* fixups for master of  `#4789 <https://github.com/mapserver/mapserver/issues/4789>`__  (Thomas Bonfort) : `f3d8234 <https://github.com/mapserver/mapserver/commit/f3d8234423a071b4d7dc46e1dd872c351e1e162f>`__
* Fix csharp build issues when doing out-of-source builds (Tamas Szekeres) : `5f1d2b5 <https://github.com/mapserver/mapserver/commit/5f1d2b53dcadf9a55cc1c1e3c08d31bb46ec0b39>`__
* use lib64 instead of lib for installing on select linux systems ( `#4789 <https://github.com/mapserver/mapserver/issues/4789>`__ ) (Thomas Bonfort) : `7de296e <https://github.com/mapserver/mapserver/commit/7de296e4155722969d6b01e22493596c3b5585df>`__
* Don't allow in-source builds, they are a source of confusion (Thomas Bonfort) : `4794f3e <https://github.com/mapserver/mapserver/commit/4794f3e70f98e2b42a453c32541118b050de78fe>`__
* Fix crash on legends with sizeunits ( `#4785 <https://github.com/mapserver/mapserver/issues/4785>`__ ) (Thomas Bonfort) : `33996f1 <https://github.com/mapserver/mapserver/commit/33996f187846a70e3a402e9367875c8df22c280b>`__
* restore mixed positions/anglemode enum (was causing backwards incompatibilities in mapscripts) (Thomas Bonfort) : `7399024 <https://github.com/mapserver/mapserver/commit/73990244c6a5883e5af4f324e7a2d2b0b8e422b1>`__
* Fix crash on legend icon with offset generation ( `#4790 <https://github.com/mapserver/mapserver/issues/4790>`__ ) (Thomas Bonfort) : `c217944 <https://github.com/mapserver/mapserver/commit/c217944d3f652edd93c6b4eb5da8f544a72ce450>`__
* Fix memory corruption on empty raster query ( `#4778 <https://github.com/mapserver/mapserver/issues/4778>`__ ) (Thomas Bonfort) : `e83a0cb <https://github.com/mapserver/mapserver/commit/e83a0cb57e554884aaf37cbae330602c726d4868>`__
* avoid erroneous hittest results for clipped shapes (Thomas Bonfort) : `eb1971b <https://github.com/mapserver/mapserver/commit/eb1971b8ae7dc5e7a4c6bf5a36850901fd3c3d1a>`__
* fix rendering of legendicons with 0-length name ( `#4782 <https://github.com/mapserver/mapserver/issues/4782>`__ ) (Thomas Bonfort) : `cea8520 <https://github.com/mapserver/mapserver/commit/cea85203de93e533e7edf301e5e3b19869bfabe5>`__
* Fix ISO C90'ism that causes MSVC compilation error (Even Rouault) : `a7ac6f7 <https://github.com/mapserver/mapserver/commit/a7ac6f750368e6cf8e14c92f1ebe94fbfadb2fd3>`__
* Fix ISO C90'ism that causes MSVC compilation error (Even Rouault) : `b52908c <https://github.com/mapserver/mapserver/commit/b52908c6ec8e081e082d425a9e081d9ebf86f444>`__
* fix segfault on label with failed scale check ( `#4781 <https://github.com/mapserver/mapserver/issues/4781>`__ ) (Thomas Bonfort) : `8250fdf <https://github.com/mapserver/mapserver/commit/8250fdf93269d132e39b094529f07477e07b2d16>`__
* update for rfc104 (Thomas Bonfort) : `1b4b59a <https://github.com/mapserver/mapserver/commit/1b4b59af9c0ba0324614a4ba49cfe99b17914a10>`__
* Fix bug with empty geometrycollections ( `#4751 <https://github.com/mapserver/mapserver/issues/4751>`__ ) (Thomas Bonfort) : `475e420 <https://github.com/mapserver/mapserver/commit/475e4200f4e7ff5f0364c15643f95747febe7923>`__
* avoid segfault on erroneous mask references ( `#4779 <https://github.com/mapserver/mapserver/issues/4779>`__ ) (Thomas Bonfort) : `8a32f71 <https://github.com/mapserver/mapserver/commit/8a32f71f8cc8ba79c80bc492b04e4ca766a7c4ed>`__
* fix segfault on UVRASTER layers with mask set ( `#4779 <https://github.com/mapserver/mapserver/issues/4779>`__ ) (Thomas Bonfort) : `942e1d7 <https://github.com/mapserver/mapserver/commit/942e1d721fcfbde75a516abf61efcbf737bde827>`__
* Fix OGR output to make it work with KML, GPX ( `#4776 <https://github.com/mapserver/mapserver/issues/4776>`__ ) (Even Rouault) : `9521529 <https://github.com/mapserver/mapserver/commit/9521529da1f33810b53850fbc06edb6296abdb6b>`__
* Declare msStringInitCap() and msStringFirstCap(), and add doc (Even Rouault) : `051e2aa <https://github.com/mapserver/mapserver/commit/051e2aa945c12cf768dcb9049a517daf34e6248d>`__
* Update mapowscommon.h (Tom Kralidis) : `a6dac28 <https://github.com/mapserver/mapserver/commit/a6dac28f8d9c8239da51cb078d826ff521591571>`__
* Update maplibxml2.h (Tom Kralidis) : `4e91ef7 <https://github.com/mapserver/mapserver/commit/4e91ef72aa7e24d2c422622c3efeb81536d95bda>`__
* Update maplibxml2.c (Tom Kralidis) : `4910928 <https://github.com/mapserver/mapserver/commit/4910928c3a5aa47303206738b99190b540e43198>`__
* Update mapowscommon.c (Tom Kralidis) : `31a229b <https://github.com/mapserver/mapserver/commit/31a229be64a36c7aeea8661bda5b2194736efeaf>`__
* Implement upper/lower/initcap/firstcap functions in the expression parser ( `#4255 <https://github.com/mapserver/mapserver/issues/4255>`__ ) (Tamas Szekeres) : `f75cf22 <https://github.com/mapserver/mapserver/commit/f75cf226da533f58fba88791ae7287d19e6536f4>`__
* skip legend rendering for empty class name/title (Thomas Bonfort) : `6f0606b <https://github.com/mapserver/mapserver/commit/6f0606bd3411de6cfaf176c595279f6249992d7b>`__
* avoid failure on capabilities legend size with empty class name (Thomas Bonfort) : `53c58d8 <https://github.com/mapserver/mapserver/commit/53c58d83bbfddf64e24a5a4aeecbcefdf658bced>`__
* RFC104: remove support for bitmap fonts, use embedded ttf instead ( `#4759 <https://github.com/mapserver/mapserver/issues/4759>`__ ) (Thomas Bonfort) : `531c0d6 <https://github.com/mapserver/mapserver/commit/531c0d605271f4153683534c404765578383ad6b>`__
* Trying to fix the build issue when allocating dynamic size array ( `#4765 <https://github.com/mapserver/mapserver/issues/4765>`__ ) (Tamas Szekeres) : `4eebb1a <https://github.com/mapserver/mapserver/commit/4eebb1a8596d95dfebe7caec7c91d926f3364818>`__
* Fixes for UTFGrid merge into master, tests added ( `#4765 <https://github.com/mapserver/mapserver/issues/4765>`__ ) (Thomas Bonfort) : `e208e84 <https://github.com/mapserver/mapserver/commit/e208e844e828e6a89195ba93c23b0390cc3b331a>`__
* RFC93: UTFGrid Implementation ( `#4765 <https://github.com/mapserver/mapserver/issues/4765>`__ ) (fdesj) : `f0a45de <https://github.com/mapserver/mapserver/commit/f0a45dedb38f1f17784a80fe01515130f6dab8dd>`__
* Add support for multiple LABEL per CLASS (Mark Thomas) : `0b8c9ab <https://github.com/mapserver/mapserver/commit/0b8c9abe4aab6cdd09f6617ad1ac7824aaa24319>`__
* Add support for expressions in labels to XML mapfile XSD and XSL (Mark Thomas) : `8b767ff <https://github.com/mapserver/mapserver/commit/8b767ffeee94501b3270c90fc59154395b41bed4>`__
* fix build when v8 is disabled (rfc 102) (Thomas Bonfort) : `a09f2ae <https://github.com/mapserver/mapserver/commit/a09f2aeadf2a07c07e919a21f5e524f3aa0d4359>`__
* Implementation of RFC 102: Styleitem Javascript with v8 engine (Alan Boudreault) : `a966c1c <https://github.com/mapserver/mapserver/commit/a966c1cf9ba0f2e8c60ac85e4e11352a0a293321>`__
* Fix A layer using a mask and a label with repeatdistance can crash ( `#4764 <https://github.com/mapserver/mapserver/issues/4764>`__ ) (Alan Boudreault) : `f82d6c8 <https://github.com/mapserver/mapserver/commit/f82d6c8946c91dbeeb38a8a7d5b0aa674f8002b3>`__
* Allow setting gamma at the layer level ( `#4763 <https://github.com/mapserver/mapserver/issues/4763>`__ ) (Thomas Bonfort) : `5a7b14c <https://github.com/mapserver/mapserver/commit/5a7b14c48496835769e937e367d37292479349fd>`__
* Fix issue with mindistance labels containing no text ( `#4673 <https://github.com/mapserver/mapserver/issues/4673>`__ ) (Thomas Bonfort) : `5db3342 <https://github.com/mapserver/mapserver/commit/5db33427efff05390e39f111cd77367401b3a1f9>`__
* Fix builds for MSVC 2003 ( `#4761 <https://github.com/mapserver/mapserver/issues/4761>`__ ) (Tamas Szekeres) : `1dc4125 <https://github.com/mapserver/mapserver/commit/1dc412537d63b5fe0eb0fe09056ef56824c57431>`__
* Remove unconditional dependency to harfbuzz (Tamas Szekeres) : `e9e306a <https://github.com/mapserver/mapserver/commit/e9e306a0cdf55292e912c61e41938c00593dfb8d>`__
* add harfbuzz to cmake status message (Thomas Bonfort) : `be17788 <https://github.com/mapserver/mapserver/commit/be1778896b37e7972f9e9185b9b8aaefd78baca3>`__
* cmake: use pg_config supplied locations if available on PATH (Thomas Bonfort) : `6c29ba6 <https://github.com/mapserver/mapserver/commit/6c29ba69fb045f1b0551327cb01307ef71686428>`__
* update HISTORY.TXT for major 7.0 features (Thomas Bonfort) : `af1419b <https://github.com/mapserver/mapserver/commit/af1419b25a3e5cae4d9c0aa39e69a445e61bcde7>`__
* add RFC103 layer->encoding implementation ( `#4758 <https://github.com/mapserver/mapserver/issues/4758>`__ ) (Thomas Bonfort) : `78916c2 <https://github.com/mapserver/mapserver/commit/78916c298add3d5505f423c1484e1680d7abb137>`__
* implement RFC98 ( `#4673 <https://github.com/mapserver/mapserver/issues/4673>`__ ) and  RFC99 ( `#4704 <https://github.com/mapserver/mapserver/issues/4704>`__ ) (Thomas Bonfort) : `18b51c4 <https://github.com/mapserver/mapserver/commit/18b51c4a36e6447793a48744f64adcb7c20585e2>`__
* Install Ruby mapscript in sitearchdir instead of archdir ( `#4754 <https://github.com/mapserver/mapserver/issues/4754>`__ ) (Bas Couwenberg) : `a70d192 <https://github.com/mapserver/mapserver/commit/a70d19228e82af9b40c423924078684d564f79a9>`__
* Install Ruby mapscript in sitearchdir instead of archdir. (Bas Couwenberg) : `c38b3b0 <https://github.com/mapserver/mapserver/commit/c38b3b0b4f75e6c9020c3431a9070e5842f27f57>`__


